package com.sagacloud.extend.dao_data;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.core.AnnotationDescription;
import com.sagacloud.util.compute_engine.core.IDao_data;
import com.sagacloud.util.compute_engine.entity.Entity_originaldata;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import org.zillion.util.json.FastJsonUtil;

import java.text.SimpleDateFormat;
import java.util.*;

@AnnotationDescription(value = "dao_data")
public class ImplDao_ori implements IDao_data {
    String database_name;
    String table_name;
    String dao_type = "ori";

    Map<String, Map<String, Entity_originaldata>> presentMapMap = new HashMap<String, Map<String, Entity_originaldata>>();

    public void SetPresent(String building, Map<String, Entity_originaldata> presentMap) {
        presentMapMap.put(building, presentMap);
    }

    @Override
    public void Initialize(String database_name) {
        this.database_name = database_name;
        this.table_name = "original_month";
    }

    @Override
    public String GetName() {
        return this.dao_type;
    }

    @Override
    public List<DoubleTimeObject> GetDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to, boolean GteLte)
            throws Exception {
        List<DoubleTimeObject> result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");
        long ori_funcid = funcid;
        if (ConstantCE.use_original_funcidMap && ConstantCE.original_funcidMap.containsKey(funcid)) {
            ori_funcid = ConstantCE.original_funcidMap.get(funcid);
        }

        String table_name_real = table_name;
        if (this.presentMapMap.containsKey(building)) {
            Map<String, Entity_originaldata> presentMap = this.presentMapMap.get(building);
            String mf = meter + "_" + ori_funcid;
            if (presentMap.containsKey(mf)) {
                Entity_originaldata Entity_originaldata = presentMap.get(mf);
                Boolean gaopin = Entity_originaldata.getGaopin();
                if (gaopin != null && gaopin.booleanValue()) {
                    table_name_real = "original_day";
                }
            }
        }

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", ori_funcid);
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        if (GteLte) {
            range.put("$lte", sdf.format(time_to));
        } else {
            range.put("$lt", sdf.format(time_to));
        }
        Criteria.put("receivetime", range);
        JSONArray resultContent = QueryUtil.select(database_name, table_name_real, Criteria);
        List<DoubleTimeObject> dataList = new ArrayList<DoubleTimeObject>();
        for (int ii = 0; ii < resultContent.size(); ii++) {
            JSONObject computelog = (JSONObject) resultContent.get(ii);
            DoubleTimeObject data = new DoubleTimeObject();
            data.data_time = sdf.parse((String) computelog.get("receivetime"));
            data.data_value = (Double) computelog.get("data");
            dataList.add(data);
        }
        result = dataList;

        return result;
    }

    @Override
    public void DeleteDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to) throws Exception {
    }

    @Override
    public void InsertDataListGteLte(JSONObject dao_key, String time_period, List<DoubleTimeObject> outputDataList) throws Exception {
    }
}
