package com.sagacloud.parser.simulator;


import cn.hutool.core.io.resource.ResourceUtil;
import org.antlr.runtime.ANTLRInputStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.tree.CommonTree;
import org.antlr.runtime.tree.CommonTreeNodeStream;

import java.util.List;

public class TestComputeEngine {
    public static void main(String[] args) throws Exception {
        ANTLRInputStream input = new ANTLRInputStream(ResourceUtil.getStream("simulator.cm"));
        ComputeEngineLexer lexer = new ComputeEngineLexer(input);
        CommonTokenStream tokens = new CommonTokenStream(lexer);
        ComputeEngineParser parser = new ComputeEngineParser(tokens);
        ComputeEngineParser.prog_return r = parser.prog();
        CommonTree t = (CommonTree) r.getTree();
        System.out.println(t.toStringTree());
        List<?> children = t.getChildren();
        System.out.println(children.size());

        CommonTreeNodeStream nodes = new CommonTreeNodeStream(t);
        nodes.setTokenStream(tokens);
        for (int i = 0; i < 1; i++) {
            ComputeEngineWalker walker = new ComputeEngineWalker(nodes);
            walker.reset();
            walker.clear();
            walker.put("t", i);
            double result = walker.prog();
            System.out.println(result);
        }
    }
}
