package com.sagacloud.util.compute_engine.core;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.extend.dao_data.ImplDao_tenantbalance;
import com.sagacloud.util.compute_engine.entity.Entity_tenant_energy_price;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.DateUtil;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.compute_engine.util.TimeSpan;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@SuppressWarnings("unchecked")
public class CoreComputeUtil_other {
    private static double value2double(Object value) throws Exception {
        if (value instanceof Integer) {
            return ((Integer) value).doubleValue();
        } else if (value instanceof Long) {
            return ((Long) value).doubleValue();
        } else if (value instanceof BigInteger) {
            return ((BigInteger) value).doubleValue();
        } else if (value instanceof Float) {
            return ((Float) value).doubleValue();
        } else if (value instanceof Double) {
            return ((Double) value).doubleValue();
        } else if (value instanceof BigDecimal) {
            return ((BigDecimal) value).doubleValue();
        } else {
            return (Double) value;
        }
    }

    public static double GetOtherValue(String tmpDate, Map<String, Object> otherMap, String other_param) throws Exception {
        if (other_param.startsWith("time_price") || other_param.startsWith("fixed_price")) {
            Map<String, List<Entity_tenant_energy_price>> priceListMap = (Map<String, List<Entity_tenant_energy_price>>) otherMap.get("priceListMap");
            int index_ = other_param.lastIndexOf("_");
            String energy_type = other_param.substring(index_ + 1);
            List<Entity_tenant_energy_price> priceList = priceListMap.get(energy_type);
            for (Entity_tenant_energy_price price : priceList) {
                if (price.getValid_time_from() == null || price.getValid_time_from().compareTo(tmpDate) <= 0) {
                    if (price.getValid_time_to() == null || price.getValid_time_to().compareTo(tmpDate) > 0) {
                        if (price.priceObject instanceof JSONObject) {
                            JSONObject json = (JSONObject) price.priceObject;
                            String JFGP = other_param.substring("time_price".length() + 1, "time_price".length() + 2);
                            return value2double(json.get(JFGP));
                        } else {
                            return value2double(price.priceObject);
                        }
                    }
                } else {
                    break;
                }
            }
        }
        throw new Exception("price not found");
    }

    public static void Compute_other(String other_type, String object_sign, String instance_name, long compute_round, CoreOutput output,
                                     String time_period, List<TimeSpan> timeSpanList, List<List<DoubleTimeObject>> outputDataListList,
                                     List<DoubleTimeObject> outputDataList_all, IDao_log dao_log) throws Exception {
        if ("tenant_ruanchongruankou".equals(other_type)) {
            JSONObject dao_key = output.dao_key;
            IDao_data dao_tenantfee = Dao_dataManager.Instance().Get("tenantfee");
            ImplDao_tenantbalance dao_tenantbalance = (ImplDao_tenantbalance) Dao_dataManager.Instance().Get("tenantbalance");
            // 起始时间和数据列表
            Date first_time = timeSpanList.get(0).timefrom;
            first_time = DateUtil.Instance().GetDate_offset(first_time, time_period, -1);
            List<DoubleTimeObject> feeList = dao_tenantfee.GetDataListGteLte(dao_key, time_period, first_time, null, true);

            // 之前的余额
            DoubleTimeObject balanceLast = dao_tenantbalance.GetData_last(dao_key, first_time);
            if (balanceLast == null) {
                balanceLast = dao_tenantbalance.GetBalance_initial(dao_key);
            }
            // 充值记录
            List<DoubleTimeObject> rechargeList = dao_tenantbalance.GetRechargeList(dao_key, first_time);
            List<DoubleTimeObject> rechargeList_used = new ArrayList<DoubleTimeObject>();
            int index_recharge = 0;
            List<DoubleTimeObject> balanceList = new ArrayList<DoubleTimeObject>();
            double tmp = balanceLast.data_value;
            for (int i = 0; i < feeList.size(); i++) {
                DoubleTimeObject fee = feeList.get(i);
                Date nextTmp = DateUtil.Instance().GetDate_offset(fee.data_time, time_period, 1);
                List<DoubleTimeObject> rechargeList_tmp = new ArrayList<DoubleTimeObject>();
                for (int ii = index_recharge; ii < rechargeList.size(); ii++) {
                    DoubleTimeObject recharge_tmp = rechargeList.get(ii);
                    index_recharge = ii;
                    if (recharge_tmp.data_time.getTime() > nextTmp.getTime()) {
                        break;
                    } else if (recharge_tmp.data_time.getTime() > fee.data_time.getTime()) {
                        rechargeList_tmp.add(recharge_tmp);
                        rechargeList_used.add(recharge_tmp);
                    }
                }
                tmp -= fee.data_value;
                for (DoubleTimeObject recharge_tmp : rechargeList_tmp) {
                    tmp += recharge_tmp.data_value;
                }
                DoubleTimeObject balance = new DoubleTimeObject();
                balance.data_time = nextTmp;
                balance.data_value = tmp;
                balanceList.add(balance);
            }
            for (DoubleTimeObject recharge_used : rechargeList_used) {
                dao_tenantbalance.SetRecharge_used(dao_key, recharge_used.data_time);
            }

            if (balanceList.size() > 0) {
                Date nextDate = DateUtil.Instance().GetDate_offset(first_time, time_period, 1);
                dao_tenantbalance.DeleteDataListGteLte(dao_key, time_period, nextDate, null);
                ConstantCE.SleepBetweenDeleteAndInsert();
                dao_tenantbalance.InsertDataListGteLte(dao_key, time_period, balanceList);

                DoubleTimeObject present = balanceList.get(balanceList.size() - 1);
                DoubleTimeObject present_exist = dao_tenantbalance.GetBalance_present(dao_key);
                if (present_exist == null) {
                    dao_tenantbalance.InsertDataBalance_present(dao_key, present);
                } else {
                    dao_tenantbalance.UpdateBalance_present(dao_key, present);
                }
            }
        }
    }
}
