package com.sagacloud.util.compute_engine.fjd;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.util.common.ZillionConstant;
import org.apache.hadoop.conf.Configuration;

import java.io.InputStream;

public class ComputeEngineReset {

    public static void main(String[] args) throws Exception {
        ZillionConstant.ObserverWait = 0L;

        Configuration configuration = new Configuration();
        InputStream inCoreSite = ConstantCE.getStream("core-site.xml");
        configuration.addResource(inCoreSite);
        InputStream inHbaseSite = ConstantCE.getStream("hbase-site.xml");
        configuration.addResource(inHbaseSite);
        InputStream inHdfsSite = ConstantCE.getStream("hdfs-site.xml");
        configuration.addResource(inHdfsSite);
        ZillionAgent agent = new ZillionAgent(configuration);
        agent.Start();

        if (!QueryUtil.database_exist(ConstantCE.database_name)) {
            HBaseSaveManagerRepository.randomZillionAgent().NDL_AddDatabase(ConstantCE.database_name);
        }
        // TableUtil.DropTables( ConstantCE.database_name);
        TableUtil.AddTables(ConstantCE.database_name);
        boolean ci_include = false;
        boolean is_clear = false;
        boolean only_log = true;
        TableUtil.ClearTables(ConstantCE.database_name, ci_include, is_clear, only_log);

        JSONArray times = QueryUtil.select(ConstantCE.database_name, "fjd_0_buildingcomputetime", new JSONObject());
        for (int i = 0; i < times.size(); i++) {
            JSONObject time = (JSONObject) times.get(i);
            JSONObject Criteria = new JSONObject();
            Criteria.put("building", time.get("building"));
            JSONObject Set = new JSONObject();
            Set.put("compute_time", time.get("first_compute_time"));
            QueryUtil.update(ConstantCE.database_name, "fjd_0_buildingcomputetime", Criteria, Set);
        }


    }

}
