package com.sagacloud.util.compute_engine.fjd;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.extend.dao_data.ImplDao_ori;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.core.*;
import com.sagacloud.util.compute_engine.entity.*;
import com.sagacloud.util.compute_engine.util.*;
import com.zillion.util.common.ByteToObject;
import com.zillion.util.zk.ZKWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.zookeeper.data.Stat;
import org.zillion.util.json.FastJsonUtil;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

@Slf4j
public class ComputeEngineUtil {
    public static Entitys_ce_compute Begin(String database_name, String object_sign, String instance_name,
                                           List<CoreInput> inputList) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        if (instance_name.startsWith("fjd_0")) {
            Entitys_ce_compute result = null;

            Entity_fjd_0_buildingcomputetime fjd_0_buildingcomputetime;
            JSONObject Criteria = new JSONObject();
            Criteria.put("building", object_sign);
            {
                JSONArray resultContent = QueryUtil.select(database_name, "fjd_0_buildingcomputetime", Criteria);
                if (resultContent.size() == 0) {
                    return null;
                }
                fjd_0_buildingcomputetime = (Entity_fjd_0_buildingcomputetime) FastJsonUtil.To_JavaObject(resultContent.get(0),
                        Entity_fjd_0_buildingcomputetime.class);
            }

            Long curround = null;
            {
                Criteria = new JSONObject();
                Criteria.put("object_sign", object_sign);
                Criteria.put("instance_name", "fjd_0");
                JSONArray resultContent = QueryUtil.select(database_name, "ce_curround", Criteria);
                if (resultContent.size() > 0) {
                    JSONObject ce_curround = (JSONObject) resultContent.get(0);
                    curround = (Long) ce_curround.get("compute_round");
                }
            }

            // 检查是否有重算recompute请求
            {
                boolean recompute_not_processed = false;
                String compute_time_from = null;
                String compute_time_to = null;
                String detail_content = null;
                JSONObject CriteriaInner = new JSONObject();
                CriteriaInner.put("building", object_sign);
                JSONArray resultContent = QueryUtil.select(database_name, "fjd_0_compute_request", CriteriaInner);
                if (resultContent.size() > 0) {
                    JSONObject cr = (JSONObject) resultContent.get(0);
                    long is_processed = (Long) cr.get("is_processed");
                    if (is_processed == 0) {
                        recompute_not_processed = true;
                        compute_time_from = (String) cr.get("compute_time_from");
                        compute_time_to = (String) cr.get("compute_time_to");
                        detail_content = (String) cr.get("detail_content");
                    }
                }

                long max_compute = 1000L * 60 * ConstantCE.fjd_0_MaxMinute;
                if (recompute_not_processed) {
                    long tmp_round = (curround == null ? 0 : curround) + 1;
                    for (Date tmp = sdf.parse(compute_time_from); tmp.getTime() < sdf.parse(compute_time_to)
                            .getTime(); tmp = new Date(tmp.getTime() + max_compute)) {
                        Date next_tmp = new Date(tmp.getTime() + max_compute);
                        String inner_time_to = sdf.format(next_tmp);
                        if (inner_time_to.compareTo(compute_time_to) > 0) {
                            inner_time_to = compute_time_to;
                        }
                        JSONObject InsertObject = new JSONObject();
                        InsertObject.put("building", object_sign);
                        InsertObject.put("compute_round", tmp_round++);
                        InsertObject.put("compute_time_from", sdf.format(tmp));
                        InsertObject.put("compute_time_to", inner_time_to);
                        InsertObject.put("detail_content", detail_content);
                        InsertObject.put("is_finished", 0L);
                        InsertObject.put("is_recompute", 1L);
                        InsertObject.put("operate_time_from", null);
                        InsertObject.put("operate_time_to", null);
                        QueryUtil.insert(database_name, "fjd_0_computelog", InsertObject);
                    }
                    Generate_round(database_name, object_sign, "fjd_0", tmp_round - 1);
                    JSONObject Set = new JSONObject();
                    Set.put("is_processed", 1L);
                    QueryUtil.update(database_name, "fjd_0_compute_request", CriteriaInner, Set);
                }
            }

            JSONObject ce_computelog_not_finished = null;
            long sub = 1L;
            while (true) {
                long start_round = (curround == null ? 0 : curround) - sub;
                sub *= 2;
                JSONObject CriteriaInner = new JSONObject();
                CriteriaInner.put("building", object_sign);
                JSONObject range = new JSONObject();
                range.put("$gte", start_round < 1 ? 1 : start_round);
                CriteriaInner.put("compute_round", range);
                JSONArray resultContent = QueryUtil.select(database_name, "fjd_0_computelog", CriteriaInner);
                boolean find_finished = false;
                JSONObject not_finished_inner = null;
                if (resultContent.size() > 0) {
                    for (int i = 0; i < resultContent.size(); i++) {
                        JSONObject ce_computelogInner = (JSONObject) resultContent.get(i);
                        long is_finished = (Long) ce_computelogInner.get("is_finished");
                        if (is_finished == 0L) {
                            not_finished_inner = ce_computelogInner;
                            break;
                        } else {
                            find_finished = true;
                        }
                    }
                }
                if (start_round <= 1 || find_finished) {
                    if (not_finished_inner != null) {
                        ce_computelog_not_finished = not_finished_inner;
                    }
                    break;
                }
            }

            Entity_fjd_0_computelog fjd_0_computelog = new Entity_fjd_0_computelog();
            if (ce_computelog_not_finished != null) {
                result = new Entitys_ce_compute();

                Entity_fjd_0_computelog computelog = (Entity_fjd_0_computelog) FastJsonUtil.To_JavaObject(ce_computelog_not_finished,
                        Entity_fjd_0_computelog.class);
                result.log = new Entity_ce_computelog();
                result.log.compute_round = computelog.compute_round;
                result.log.compute_time_from = computelog.compute_time_from;
                result.log.compute_time_to = computelog.compute_time_to;
                result.log.is_finished = computelog.is_finished;
                result.is_recompute = computelog.is_recompute;
                fjd_0_computelog.building = object_sign;
                fjd_0_computelog.compute_round = result.log.compute_round;
                fjd_0_computelog.compute_time_from = result.log.compute_time_from;
                fjd_0_computelog.compute_time_to = result.log.compute_time_to;
                fjd_0_computelog.is_finished = result.log.is_finished;
                fjd_0_computelog.is_recompute = result.is_recompute;
                fjd_0_computelog.detail_content = computelog.detail_content;

                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", object_sign);
                    CriteriaInner.put("compute_round", result.log.compute_round);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_0_computedetail", CriteriaInner);
                    for (int i = 0; i < resultContentInner.size(); i++) {
                        JSONObject ce_computeoutputdetail = (JSONObject) resultContentInner.get(i);
                        Entity_fjd_0_computedetail detail = (Entity_fjd_0_computedetail) FastJsonUtil.To_JavaObject(ce_computeoutputdetail,
                                Entity_fjd_0_computedetail.class);
                        if (!result.outputdetailListMap.containsKey("fjd_0_" + detail.meter + "_" + detail.funcid)) {
                            result.outputdetailListMap.put("fjd_0_" + detail.meter + "_" + detail.funcid, new ArrayList<TimeSpan>());
                        }
                        List<TimeSpan> timeSpanList = result.outputdetailListMap.get("fjd_0_" + detail.meter + "_" + detail.funcid);
                        timeSpanList.add(new TimeSpan(detail.valid_time_from, detail.valid_time_to));
                    }
                }
            } else {
                Date currentTime = new Date();
                Date hourTime = new Date(currentTime.getTime() / (1000L * 60 * 60) * (1000L * 60 * 60) + (1000L * 60 * 60));
                result = new Entitys_ce_compute();
                result.log = new Entity_ce_computelog();
                result.log.compute_round = (curround == null ? 0 : curround) + 1;
                result.log.compute_time_from = fjd_0_buildingcomputetime.getCompute_time();
                result.log.compute_time_to = fjd_0_buildingcomputetime.getCompute_time();
                if (hourTime.compareTo(result.log.compute_time_from) > 0) {
                    long max_compute = 1000L * 60 * ConstantCE.fjd_0_MaxMinute;
                    if (hourTime.getTime() - result.log.compute_time_from.getTime() > max_compute) {
                        result.log.compute_time_to = new Date(result.log.compute_time_from.getTime() + max_compute);
                    } else {
                        result.log.compute_time_to = hourTime;
                    }
                }
                result.log.is_finished = 0L;

                fjd_0_computelog.building = object_sign;
                fjd_0_computelog.compute_round = result.log.compute_round;
                fjd_0_computelog.compute_time_from = result.log.compute_time_from;
                fjd_0_computelog.compute_time_to = result.log.compute_time_to;
                fjd_0_computelog.is_finished = result.log.is_finished;
            }

            Map<String, Entity_fjd_0_metercomputetime> fjd_0_metercomputetimeMap = new HashMap<String, Entity_fjd_0_metercomputetime>();
            Map<String, Entity_originaldata> originaldatapresentMap = new HashMap<String, Entity_originaldata>();
            JSONObject CriteriaInner = new JSONObject();
            CriteriaInner.put("building", object_sign);
            {
                JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_0_metercomputetime", CriteriaInner);
                for (int i = 0; i < resultContentInner.size(); i++) {
                    Entity_fjd_0_metercomputetime detail = (Entity_fjd_0_metercomputetime) FastJsonUtil
                            .To_JavaObject(resultContentInner.get(i), Entity_fjd_0_metercomputetime.class);
                    fjd_0_metercomputetimeMap.put(detail.meter + "_" + detail.funcid, detail);
                }
            }
            {
                JSONArray resultContentInner = QueryUtil.select(database_name, "original_present", CriteriaInner);
                for (int i = 0; i < resultContentInner.size(); i++) {
                    Entity_originaldata detail = (Entity_originaldata) FastJsonUtil.To_JavaObject(resultContentInner.get(i),
                            Entity_originaldata.class);
                    originaldatapresentMap.put(detail.meter + "_" + detail.funcid, detail);
                }
                ImplDao_ori ImplDao_ori = (ImplDao_ori) Dao_dataManager.Instance().Get("ori");
                ImplDao_ori.SetPresent(object_sign, originaldatapresentMap);
            }
            Map<String, Boolean> detail_content_pointMap = new HashMap<String, Boolean>();
            if (fjd_0_computelog.is_recompute == 1L && fjd_0_computelog.detail_content != null) {
                JSONObject detail_content = (JSONObject) JSON.parse(fjd_0_computelog.detail_content);
                JSONArray points = (JSONArray) detail_content.get("points");
                for (int i = 0; i < points.size(); i++) {
                    String point = (String) points.get(i);
                    detail_content_pointMap.put(point, true);
                }
            }
            for (CoreInput input : inputList) {
                String meter = (String) input.dao_key.get("meter");
                Long funcid = FastJsonUtil.getLong(input.dao_key, "funcid");
                if (result.outputdetailListMap.containsKey(meter + "_" + funcid)) {
                    continue;
                }
                if (!"ori".equals(input.dao_type)) {
                    continue;
                }

                long ori_funcid = funcid;
                if (ConstantCE.use_original_funcidMap && ConstantCE.original_funcidMap.containsKey(funcid)) {
                    ori_funcid = ConstantCE.original_funcidMap.get(funcid);
                }
                long interval = DateUtil.Instance().get_about(input.time_period);
                if (fjd_0_computelog.is_recompute == 1L) {
                    if (fjd_0_computelog.detail_content == null || detail_content_pointMap.containsKey(meter + "_" + funcid)) {
                        if (!result.inputdetailListMap.containsKey("ori_" + meter + "_" + funcid)) {
                            result.inputdetailListMap.put("ori_" + meter + "_" + funcid, new ArrayList<TimeSpan>());
                        }
                        result.inputdetailListMap.get("ori_" + meter + "_" + funcid).add(
                                new TimeSpan(new Date(fjd_0_computelog.compute_time_from.getTime() + interval), fjd_0_computelog.compute_time_to));
                    }
                } else {
                    if (originaldatapresentMap.containsKey(meter + "_" + ori_funcid)) {
                        Entity_originaldata originaldatapresent = originaldatapresentMap.get(meter + "_" + ori_funcid);
                        // 当前值original_present允许计算到哪个时间点
                        Date time_canCompute = new Date(originaldatapresent.receivetime.getTime() / interval * interval);
                        if (input.source_output_sign.startsWith("Acc" + "_") || input.source_output_sign.startsWith("Inst" + "_")
                                || input.source_output_sign.startsWith("InAc" + "_")) {
                            if ((interval - (originaldatapresent.receivetime.getTime() - time_canCompute.getTime())) * 3 <= interval) {
                                time_canCompute = new Date(time_canCompute.getTime() + interval);
                            }
                        }
                        // 根据项目本轮的时间范围和当前值允许范围，确定计算到哪个时间点
                        time_canCompute = result.log.compute_time_to.compareTo(time_canCompute) > 0 ? time_canCompute : result.log.compute_time_to;
                        Entity_fjd_0_metercomputetime fjd_0_metercomputetime;
                        if (!fjd_0_metercomputetimeMap.containsKey(meter + "_" + funcid)) {
                            fjd_0_metercomputetime = new Entity_fjd_0_metercomputetime();
                            fjd_0_metercomputetime.building = object_sign;
                            fjd_0_metercomputetime.meter = meter;
                            fjd_0_metercomputetime.funcid = funcid;
                            fjd_0_metercomputetime.next_data_time = result.log.compute_time_from;
                            fjd_0_metercomputetime.first_compute_time = fjd_0_metercomputetime.next_data_time;
                            JSONObject InsertObject = (JSONObject) FastJsonUtil.To_JSON(fjd_0_metercomputetime);
                            QueryUtil.insert(database_name, "fjd_0_metercomputetime", InsertObject);
                        } else {
                            fjd_0_metercomputetime = fjd_0_metercomputetimeMap.get(meter + "_" + funcid);
                        }

                        Date meter_data_time = new Date(fjd_0_metercomputetime.next_data_time.getTime() / interval * interval);
                        if (meter_data_time.getTime() > result.log.compute_time_from.getTime() + interval) {
                            meter_data_time = new Date(result.log.compute_time_from.getTime() + interval);
                        }
                        if (result.log.compute_time_from.getTime() - meter_data_time.getTime() > 1000L * 60 * 60 * 24 * ConstantCE.fjd_0_LagDay) {
                            meter_data_time = new Date(result.log.compute_time_from.getTime() - 1000L * 60 * 60 * 24 * ConstantCE.fjd_0_LagDay);
                        }
                        if (time_canCompute.compareTo(meter_data_time) >= 0) {
                            if (!result.inputdetailListMap.containsKey("ori_" + meter + "_" + funcid)) {
                                result.inputdetailListMap.put("ori_" + meter + "_" + funcid, new ArrayList<TimeSpan>());
                            }
                            result.inputdetailListMap.get("ori_" + meter + "_" + funcid).add(new TimeSpan(meter_data_time, time_canCompute));
                        }
                    }
                }
            }

            if (ce_computelog_not_finished == null) {
                Criteria = new JSONObject();
                Criteria.put("building", object_sign);
                boolean need_compute_report = false;
                JSONArray content_originalreport_round = QueryUtil.select(database_name, "originalreport_round", Criteria);
                if (content_originalreport_round.size() > 0) {
                    JSONObject originalreport_round = (JSONObject) content_originalreport_round.get(0);
                    long round_exist = (Long) originalreport_round.get("round_exist");
                    long round_used = (Long) originalreport_round.get("round_used");
                    if (round_used != round_exist) {
                        need_compute_report = true;
                    }
                }
                if (result.inputdetailListMap.size() > 0 || need_compute_report) {
                    Generate_round(database_name, object_sign, "fjd_0", fjd_0_computelog.compute_round);
                    JSONObject InsertObject = (JSONObject) FastJsonUtil.To_JSON(fjd_0_computelog);
                    InsertObject.put("operate_time_from", sdf.format(new Date()));
                    QueryUtil.insert(database_name, "fjd_0_computelog", InsertObject);
                } else {
                    return null;
                }
            }

            return result;
        } else if (instance_name.startsWith("fjd_1")) {
            Entitys_ce_compute result = null;

            String building = object_sign;
            Entity_fjd_1_computelog computelog = null;
            JSONObject Criteria = new JSONObject();

            Long curround = null;
            {
                Criteria = new JSONObject();
                Criteria.put("object_sign", building);
                Criteria.put("instance_name", "fjd_1");
                JSONArray resultContent = QueryUtil.select(database_name, "ce_curround", Criteria);
                if (resultContent.size() > 0) {
                    JSONObject ce_curround = (JSONObject) resultContent.get(0);
                    curround = (Long) ce_curround.get("compute_round");
                }
            }
            JSONObject entity = null;
            Long last_finished = null;
            {
                Criteria = new JSONObject();
                Criteria.put("building", building);
                if (curround != null) {
                    JSONObject range = new JSONObject();
                    range.put("$gte", curround - 1);
                    Criteria.put("compute_round", range);
                }
                JSONArray resultContent = QueryUtil.select(database_name, "fjd_1_computelog", Criteria);
                if (resultContent.size() > 0) {
                    entity = (JSONObject) resultContent.get(resultContent.size() - 1);
                    last_finished = (Long) entity.get("is_finished");
                }
            }

            if (entity != null && last_finished.intValue() == 0) {
                result = new Entitys_ce_compute();

                computelog = (Entity_fjd_1_computelog) FastJsonUtil.To_JavaObject(entity, Entity_fjd_1_computelog.class);
                result.log = new Entity_ce_computelog();
                result.log.compute_round = computelog.compute_round;
                result.log.compute_time_from = computelog.compute_time_from;
                result.log.compute_time_to = computelog.compute_time_to;
                result.log.is_finished = computelog.is_finished;

                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", object_sign);
                    CriteriaInner.put("compute_round", result.log.compute_round);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_1_computedetail", CriteriaInner);
                    for (int i = 0; i < resultContentInner.size(); i++) {
                        JSONObject ce_computeoutputdetail = (JSONObject) resultContentInner.get(i);
                        Entity_fjd_1_computedetail detail = (Entity_fjd_1_computedetail) FastJsonUtil.To_JavaObject(ce_computeoutputdetail,
                                Entity_fjd_1_computedetail.class);
                        if (!result.outputdetailListMap.containsKey("fjd_1_" + detail.meter + "_" + detail.funcid)) {
                            result.outputdetailListMap.put("fjd_1_" + detail.meter + "_" + detail.funcid, new ArrayList<TimeSpan>());
                        }
                        List<TimeSpan> timeSpanList = result.outputdetailListMap.get("fjd_1_" + detail.meter + "_" + detail.funcid);
                        timeSpanList.add(new TimeSpan(detail.valid_time_from, detail.valid_time_to));
                    }
                }
            } else {
                curround = 0L;
                long last_fjd_compute_round_to = 0;
                if (entity != null) {
                    curround = (Long) entity.get("compute_round");
                    last_fjd_compute_round_to = (Long) entity.get("fjd_compute_round_to");
                }
                entity = null;

                Criteria = new JSONObject();
                Criteria.put("building", building);
                JSONObject range = new JSONObject();
                range.put("$gt", last_fjd_compute_round_to);
                Criteria.put("compute_round", range);
                JSONArray resultContent = QueryUtil.select(database_name, "fjd_0_computelog", Criteria);
                // 先取已结束，预留两轮空隙
                List<JSONObject> dataList_finish = new ArrayList<JSONObject>();
                for (int m = 0; m < resultContent.size() - ConstantCE.fjd_1_lag_cycle_count; m++) {
                    JSONObject json = (JSONObject) resultContent.get(m);
                    Long is_finished = (Long) json.get("is_finished");
                    Long is_recompute = (Long) json.get("is_recompute");
                    if (is_finished == 0) {
                        break;
                    }
                    // 重算不驱动fjd_1
                    if (is_recompute != null && is_recompute == 1) {
                        continue;
                    }
                    dataList_finish.add(json);
                }
                if (dataList_finish.size() > 0) {
                    Entity_fjd_0_computelog computelog0_frist = (Entity_fjd_0_computelog) FastJsonUtil.To_JavaObject(dataList_finish.get(0),
                            Entity_fjd_0_computelog.class);
                    Entity_fjd_0_computelog computelog0_final = null;
                    List<JSONObject> dataList_span = new ArrayList<JSONObject>();
                    for (int m = 0; m < dataList_finish.size(); m++) {
                        Entity_fjd_0_computelog computelog0_tmp = (Entity_fjd_0_computelog) FastJsonUtil.To_JavaObject(dataList_finish.get(m),
                                Entity_fjd_0_computelog.class);
                        JSONObject json = dataList_finish.get(m);
                        String time_from = (String) json.get("compute_time_from");
                        String time_to = (String) json.get("compute_time_to");
                        dataList_span.add(json);

                        if (sdf.parse(time_to).getTime() - computelog0_frist.compute_time_from.getTime() >= 1000
                                * ConstantCE.fjd_1_compute_min_span_second) {
                            computelog0_final = computelog0_tmp;
                            break;
                        }

                        if (m < dataList_finish.size() - 1) {
                            JSONObject jsonNext = dataList_finish.get(m + 1);
                            String time_fromNext = (String) jsonNext.get("compute_time_from");
                            String time_toNext = (String) jsonNext.get("compute_time_to");
                            if (time_fromNext.compareTo(time_from) >= 0 && time_fromNext.compareTo(time_to) <= 0
                                    && time_toNext.compareTo(time_to) >= 0) {
                            } else {
                                computelog0_final = computelog0_tmp;
                                break;
                            }
                        }
                    }
                    if (computelog0_final != null) {
                        result = new Entitys_ce_compute();
                        result.log = new Entity_ce_computelog();
                        result.log.compute_round = (curround == null ? 0 : curround) + 1;
                        result.log.compute_time_from = computelog0_frist.compute_time_from;
                        result.log.compute_time_to = computelog0_final.compute_time_to;
                        result.log.is_finished = 0L;

                        Generate_round(database_name, object_sign, "fjd_1", result.log.compute_round);
                        computelog = new Entity_fjd_1_computelog();
                        computelog.building = building;
                        computelog.compute_round = result.log.compute_round;
                        computelog.fjd_compute_round_from = computelog0_frist.compute_round;
                        computelog.fjd_compute_round_to = computelog0_final.compute_round;
                        computelog.compute_time_from = computelog0_frist.compute_time_from;
                        computelog.compute_time_to = computelog0_final.compute_time_to;
                        computelog.is_finished = 0L;
                        JSONObject InsertObject = (JSONObject) FastJsonUtil.To_JSON(computelog);
                        InsertObject.put("operate_time_from", sdf.format(new Date()));
                        QueryUtil.insert(database_name, "fjd_1_computelog", InsertObject);
                    }
                }
            }

            if (result != null) {
                JSONObject CriteriaInner = new JSONObject();
                CriteriaInner.put("building", object_sign);
                JSONObject Range = new JSONObject();
                Range.put("$gte", computelog.fjd_compute_round_from);
                Range.put("$lte", computelog.fjd_compute_round_to);
                CriteriaInner.put("compute_round", Range);
                JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_0_computedetail", CriteriaInner);
                for (int i = 0; i < resultContentInner.size(); i++) {
                    JSONObject ce_computeoutputdetail = (JSONObject) resultContentInner.get(i);
                    Entity_fjd_1_computedetail detail = (Entity_fjd_1_computedetail) FastJsonUtil.To_JavaObject(ce_computeoutputdetail,
                            Entity_fjd_1_computedetail.class);
                    if (!result.inputdetailListMap.containsKey(detail.meter + "_" + detail.funcid)) {
                        result.inputdetailListMap.put(detail.meter + "_" + detail.funcid, new ArrayList<TimeSpan>());
                    }
                    List<TimeSpan> timeSpanList = result.inputdetailListMap.get(detail.meter + "_" + detail.funcid);
                    timeSpanList.add(new TimeSpan(detail.valid_time_from, detail.valid_time_to));
                }
            }

            return result;
        } else {
            List<CoreOutputBag> fjd_bagList = new ArrayList<CoreOutputBag>();
            List<CoreOutputBag> other_bagList = new ArrayList<CoreOutputBag>();
            for (CoreInput input : inputList) {
                if ("fjd".equals(input.source_instance_name)) {
                    CoreOutputBag exist_bag = null;
                    for (CoreOutputBag bag : fjd_bagList) {
                        if (bag.source_object_sign.equals(input.source_object_sign) && bag.source_instance_name.equals(input.source_instance_name)) {
                            exist_bag = bag;
                            break;
                        }
                    }
                    if (exist_bag == null) {
                        exist_bag = new CoreOutputBag(input.source_object_sign, input.source_instance_name);
                        fjd_bagList.add(exist_bag);
                    }
                    exist_bag.outputMap.put(input.source_output_sign, input);
                } else {
                    CoreOutputBag exist_bag = null;
                    for (CoreOutputBag bag : other_bagList) {
                        if (bag.source_object_sign.equals(input.source_object_sign) && bag.source_instance_name.equals(input.source_instance_name)) {
                            exist_bag = bag;
                            break;
                        }
                    }
                    if (exist_bag == null) {
                        exist_bag = new CoreOutputBag(input.source_object_sign, input.source_instance_name);
                        other_bagList.add(exist_bag);
                    }
                    exist_bag.outputMap.put(input.source_output_sign, input);
                }
            }

            Entitys_ce_compute result = Begin_ce_compute(database_name, object_sign, instance_name, fjd_bagList, other_bagList);

            return result;
        }
    }

    private static Entitys_ce_compute Begin_ce_compute(String database_name, String object_sign, String instance_name,
                                                       List<CoreOutputBag> fjd_bagList, List<CoreOutputBag> other_bagList) throws Exception {
        Entitys_ce_compute result = null;

        Long curround = 0L;
        JSONObject ce_computelog_not_finished = null;
        {
            JSONObject Criteria = new JSONObject();
            Criteria.put("object_sign", object_sign);
            Criteria.put("instance_name", instance_name);
            JSONArray resultContent = QueryUtil.select(database_name, "ce_curround", Criteria);
            if (resultContent.size() > 0) {
                JSONObject ce_curround = (JSONObject) resultContent.get(0);
                curround = (Long) ce_curround.get("compute_round");
            }
        }
        long sub = 1L;
        while (true) {
            long start_round = curround - sub;
            sub *= 2;
            JSONObject Criteria = new JSONObject();
            Criteria.put("object_sign", object_sign);
            Criteria.put("instance_name", instance_name);
            JSONObject range = new JSONObject();
            range.put("$gte", start_round < 1 ? 1 : start_round);
            Criteria.put("compute_round", range);
            JSONArray resultContent = QueryUtil.select(database_name, "ce_computelog", Criteria);
            boolean find_finished = false;
            JSONObject not_finished_inner = null;
            if (resultContent.size() > 0) {
                for (int i = 0; i < resultContent.size(); i++) {
                    JSONObject ce_computelogInner = (JSONObject) resultContent.get(i);
                    long is_finished = (Long) ce_computelogInner.get("is_finished");
                    if (is_finished == 0L) {
                        not_finished_inner = ce_computelogInner;
                        break;
                    } else {
                        find_finished = true;
                    }
                }
            }
            if (start_round <= 1 || find_finished) {
                if (not_finished_inner != null) {
                    ce_computelog_not_finished = not_finished_inner;
                }
                break;
            }
        }

        if (ce_computelog_not_finished != null) {
            result = new Entitys_ce_compute();

            result.log = (Entity_ce_computelog) FastJsonUtil.To_JavaObject((ce_computelog_not_finished), Entity_ce_computelog.class);

            {
                JSONObject CriteriaInner = new JSONObject();
                CriteriaInner.put("object_sign", object_sign);
                CriteriaInner.put("instance_name", instance_name);
                CriteriaInner.put("compute_round", result.log.compute_round);
                JSONArray resultContentInner = QueryUtil.select(database_name, "ce_computeinputdetail", CriteriaInner);
                for (int i = 0; i < resultContentInner.size(); i++) {
                    JSONObject ce_computeoutputdetail = (JSONObject) resultContentInner.get(i);
                    Entity_ce_computeinputdetail detail = (Entity_ce_computeinputdetail) FastJsonUtil.To_JavaObject(ce_computeoutputdetail,
                            Entity_ce_computeinputdetail.class);
                    if (!result.inputdetailListMap.containsKey(detail.input_sign)) {
                        result.inputdetailListMap.put(detail.input_sign, new ArrayList<TimeSpan>());
                    }
                    List<TimeSpan> timeSpanList = result.inputdetailListMap.get(detail.input_sign);
                    timeSpanList.add(new TimeSpan(detail.valid_time_from, detail.valid_time_to));
                }
            }
            {
                JSONObject CriteriaInner = new JSONObject();
                CriteriaInner.put("object_sign", object_sign);
                CriteriaInner.put("instance_name", instance_name);
                CriteriaInner.put("compute_round", result.log.compute_round);
                JSONArray resultContentInner = QueryUtil.select(database_name, "ce_computeoutputdetail", CriteriaInner);
                for (int i = 0; i < resultContentInner.size(); i++) {
                    JSONObject ce_computeoutputdetail = (JSONObject) resultContentInner.get(i);
                    Entity_ce_computeoutputdetail detail = (Entity_ce_computeoutputdetail) FastJsonUtil.To_JavaObject(ce_computeoutputdetail,
                            Entity_ce_computeoutputdetail.class);
                    if (!result.outputdetailListMap.containsKey(detail.output_sign)) {
                        result.outputdetailListMap.put(detail.output_sign, new ArrayList<TimeSpan>());
                    }
                    List<TimeSpan> timeSpanList = result.outputdetailListMap.get(detail.output_sign);
                    timeSpanList.add(new TimeSpan(detail.valid_time_from, detail.valid_time_to));
                }
            }
        } else {
            List<Entitys_ce_compute> postcomputeList = Generate_ce_computeList(database_name, object_sign, instance_name, fjd_bagList,
                    other_bagList, curround);
            if (postcomputeList.size() > 0) {
                result = postcomputeList.get(0);
            }
        }

        return result;
    }

    private static List<Entitys_ce_compute> Generate_ce_computeList(String database_name, String object_sign,
                                                                    String instance_name, List<CoreOutputBag> fjd_bagList, List<CoreOutputBag> other_bagList, long curround) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        List<Entitys_ce_compute> postcomputeList = new ArrayList<Entitys_ce_compute>();
        List<Entitys_ce_compute> postcomputeList_recompute = new ArrayList<Entitys_ce_compute>();

        CoreOutputBag[] all_bags;
        {
            int fjd_count = 4;
            all_bags = new CoreOutputBag[other_bagList.size() + fjd_bagList.size() * fjd_count];
            for (int i = 0; i < other_bagList.size(); i++) {
                all_bags[i] = other_bagList.get(i);
            }
            for (int i = 0; i < fjd_bagList.size(); i++) {
                CoreOutputBag bag = fjd_bagList.get(i);
                all_bags[other_bagList.size() + fjd_bagList.size() * 0 + i * fjd_count] = new CoreOutputBag(bag.source_object_sign, "fjd_1");
                all_bags[other_bagList.size() + fjd_bagList.size() * 0 + i * fjd_count].outputMap = bag.outputMap;
                all_bags[other_bagList.size() + fjd_bagList.size() * 1 + i * fjd_count] = new CoreOutputBag(bag.source_object_sign, "fjd_0");
                all_bags[other_bagList.size() + fjd_bagList.size() * 1 + i * fjd_count].outputMap = bag.outputMap;
                all_bags[other_bagList.size() + fjd_bagList.size() * 2 + i * fjd_count] = new CoreOutputBag(bag.source_object_sign, "fjd_2");
                all_bags[other_bagList.size() + fjd_bagList.size() * 2 + i * fjd_count].outputMap = bag.outputMap;
                all_bags[other_bagList.size() + fjd_bagList.size() * 3 + i * fjd_count] = new CoreOutputBag(bag.source_object_sign, "fjd_3");
                all_bags[other_bagList.size() + fjd_bagList.size() * 3 + i * fjd_count].outputMap = bag.outputMap;
            }
        }

        long[] exist_rounds = new long[all_bags.length];
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONArray resultContent = QueryUtil.select(database_name, "ce_preroundindex", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject ce_preroundindex = (JSONObject) resultContent.get(i);
            String source_object_sign = (String) ce_preroundindex.get("source_object_sign");
            String source_instance_name = (String) ce_preroundindex.get("source_instance_name");
            long compute_round = (Long) ce_preroundindex.get("compute_round");
            for (int ii = 0; ii < all_bags.length; ii++) {
                CoreOutputBag bag = all_bags[ii];
                if (bag.source_object_sign.equals(source_object_sign) && bag.source_instance_name.equals(source_instance_name)) {
                    exist_rounds[ii] = compute_round;
                    break;
                }
            }
        }

        List<?>[] logLists = new List<?>[all_bags.length];
        List<?>[] detailLists = new List<?>[all_bags.length];
        int[][] log_usedss = new int[all_bags.length][];

        for (int i = 0; i < all_bags.length; i++) {
            CoreOutputBag bag = all_bags[i];
            Map<String, CoreInput> outputMap = bag.outputMap;
            String source_object_sign = bag.source_object_sign;
            String source_instance_name = bag.source_instance_name;
            long exist_round = exist_rounds[i];
            List<Entity_ces_log> logList = new ArrayList<Entity_ces_log>();
            List<Entity_ces_detail> detailList = new ArrayList<Entity_ces_detail>();

            if (source_instance_name.startsWith("fjd_0")) {
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", source_object_sign);
                    JSONObject range = new JSONObject();
                    range.put("$gt", exist_round);
                    CriteriaInner.put("compute_round", range);
                    JSONObject LimitInner = new JSONObject();
                    LimitInner.put("Skip", 0L);
                    LimitInner.put("Count", 1440L);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_0_computelog", CriteriaInner, null, LimitInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                        Entity_fjd_0_computelog entity = (Entity_fjd_0_computelog) FastJsonUtil.To_JavaObject(computelog,
                                Entity_fjd_0_computelog.class);
                        if (entity.is_finished == 1) {
                            Entity_ces_log log = new Entity_ces_log();
                            log.compute_round = entity.compute_round;
                            log.compute_time_from = entity.compute_time_from;
                            log.compute_time_to = entity.compute_time_to;
                            log.is_recompute = entity.is_recompute;
                            logList.add(log);
                        }
                    }
                }

                if (logList.size() > 0) {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", source_object_sign);
                    JSONObject range = new JSONObject();
                    range.put("$gte", logList.get(0).compute_round);
                    range.put("$lte", logList.get(logList.size() - 1).compute_round);
                    CriteriaInner.put("compute_round", range);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_0_computedetail", CriteriaInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computedetail = (JSONObject) resultContentInner.get(ii);
                        String meter = (String) computedetail.get("meter");
                        long funcid = FastJsonUtil.getLong(computedetail, "funcid");
                        if (outputMap.containsKey(meter + "_" + funcid)) {
                            Entity_fjd_0_computedetail entity = (Entity_fjd_0_computedetail) FastJsonUtil.To_JavaObject(computedetail,
                                    Entity_fjd_0_computedetail.class);
                            Entity_ces_detail detail = new Entity_ces_detail();
                            detail.compute_round = entity.compute_round;
                            detail.output_sign = entity.meter + "_" + entity.funcid;
                            detail.valid_time_from = entity.valid_time_from;
                            detail.valid_time_to = entity.valid_time_to;
                            detailList.add(detail);
                        }
                    }
                }
            } else if ("fjd_1".equals(source_instance_name)) {
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", source_object_sign);
                    JSONObject range = new JSONObject();
                    range.put("$gt", exist_round);
                    CriteriaInner.put("compute_round", range);
                    JSONObject LimitInner = new JSONObject();
                    LimitInner.put("Skip", 0L);
                    LimitInner.put("Count", 1440L);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_1_computelog", CriteriaInner, null, LimitInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                        Entity_fjd_1_computelog entity = (Entity_fjd_1_computelog) FastJsonUtil.To_JavaObject(computelog,
                                Entity_fjd_1_computelog.class);
                        if (entity.is_finished == 1) {
                            Entity_ces_log log = new Entity_ces_log();
                            log.compute_round = entity.compute_round;
                            log.compute_time_from = entity.compute_time_from;
                            log.compute_time_to = entity.compute_time_to;
                            logList.add(log);
                        }
                    }
                }

                if (logList.size() > 0) {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", source_object_sign);
                    JSONObject range = new JSONObject();
                    range.put("$gte", logList.get(0).compute_round);
                    range.put("$lte", logList.get(logList.size() - 1).compute_round);
                    CriteriaInner.put("compute_round", range);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_1_computedetail", CriteriaInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computedetail = (JSONObject) resultContentInner.get(ii);
                        String meter = (String) computedetail.get("meter");
                        long funcid = FastJsonUtil.getLong(computedetail, "funcid");
                        if (outputMap.containsKey(meter + "_" + funcid)) {
                            Entity_fjd_1_computedetail entity = (Entity_fjd_1_computedetail) FastJsonUtil.To_JavaObject(computedetail,
                                    Entity_fjd_1_computedetail.class);
                            Entity_ces_detail detail = new Entity_ces_detail();
                            detail.compute_round = entity.compute_round;
                            detail.output_sign = entity.meter + "_" + entity.funcid;
                            detail.valid_time_from = entity.valid_time_from;
                            detail.valid_time_to = entity.valid_time_to;
                            detailList.add(detail);
                        }
                    }
                }
            } else if ("fjd_2".equals(source_instance_name) || "fjd_3".equals(source_instance_name)) {
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", source_object_sign);
                    JSONObject range = new JSONObject();
                    range.put("$gt", exist_round);
                    CriteriaInner.put("compute_round", range);
                    JSONObject LimitInner = new JSONObject();
                    LimitInner.put("Skip", 0L);
                    LimitInner.put("Count", 1440L);
                    JSONArray resultContentInner = QueryUtil.select(database_name, source_instance_name + "_computelog", CriteriaInner, null,
                            LimitInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                        Entity_fjd_2_computelog entity = (Entity_fjd_2_computelog) FastJsonUtil.To_JavaObject(computelog,
                                Entity_fjd_2_computelog.class);
                        if (entity.is_finished == 1) {
                            Entity_ces_log log = new Entity_ces_log();
                            log.compute_round = entity.compute_round;
                            log.compute_time_from = entity.compute_time_from;
                            log.compute_time_to = entity.compute_time_to;
                            logList.add(log);
                        }
                    }
                }

                if (logList.size() > 0) {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", source_object_sign);
                    JSONObject range = new JSONObject();
                    range.put("$gte", logList.get(0).compute_round);
                    range.put("$lte", logList.get(logList.size() - 1).compute_round);
                    CriteriaInner.put("compute_round", range);
                    JSONArray resultContentInner = QueryUtil.select(database_name, source_instance_name + "_computedetail", CriteriaInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computedetail = (JSONObject) resultContentInner.get(ii);
                        String meter = (String) computedetail.get("meter");
                        long funcid = FastJsonUtil.getLong(computedetail, "funcid");
                        if (outputMap.containsKey(meter + "_" + funcid)) {
                            Entity_fjd_2_computedetail entity = (Entity_fjd_2_computedetail) FastJsonUtil.To_JavaObject(computedetail,
                                    Entity_fjd_2_computedetail.class);
                            Entity_ces_detail detail = new Entity_ces_detail();
                            detail.compute_round = entity.compute_round;
                            detail.output_sign = entity.meter + "_" + entity.funcid;
                            detail.valid_time_from = entity.valid_time_from;
                            detail.valid_time_to = entity.valid_time_to;
                            detailList.add(detail);
                        }
                    }
                }
            } else if ("report".equals(source_instance_name)) {
                Map<String, CoreInput> outputMapInner = null;
                for (CoreOutputBag ob : other_bagList) {
                    if (ob.source_object_sign.equals(source_object_sign) && ob.source_instance_name.equals(source_instance_name)) {
                        outputMapInner = ob.outputMap;
                        break;
                    }
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", source_object_sign);
                    JSONObject range = new JSONObject();
                    range.put("$gt", exist_round);
                    CriteriaInner.put("round", range);
                    JSONObject LimitInner = new JSONObject();
                    LimitInner.put("Skip", 0L);
                    LimitInner.put("Count", 1440L);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "originalreport_log", CriteriaInner, null, LimitInner);
                    Long round_used = null;
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                        long round = (Long) computelog.get("round");
                        String meter = (String) computelog.get("meter");
                        long funcid = (Long) computelog.get("funcid");
                        round_used = round;
                        Entity_ces_log log = new Entity_ces_log();
                        log.compute_round = round;
                        log.compute_time_from = sdf.parse((String) computelog.get("receivetime"));
                        log.compute_time_to = sdf.parse((String) computelog.get("receivetime"));
                        logList.add(log);
                        if (outputMapInner.containsKey(meter + "_" + funcid)) {
                            Entity_ces_detail detail = new Entity_ces_detail();
                            detail.compute_round = round;
                            detail.output_sign = meter + "_" + funcid;
                            detail.valid_time_from = sdf.parse((String) computelog.get("receivetime"));
                            detail.valid_time_to = sdf.parse((String) computelog.get("receivetime"));
                            detailList.add(detail);
                        }
                    }
                    if (round_used != null) {
                        CriteriaInner = new JSONObject();
                        CriteriaInner.put("building", source_object_sign);
                        JSONObject Set = new JSONObject();
                        Set.put("round_used", round_used);
                        QueryUtil.update(database_name, "originalreport_round", CriteriaInner, Set);
                    }
                }
            } else {
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("object_sign", source_object_sign);
                    CriteriaInner.put("instance_name", source_instance_name);
                    JSONObject range = new JSONObject();
                    range.put("$gt", exist_round);
                    CriteriaInner.put("compute_round", range);
                    JSONObject LimitInner = new JSONObject();
                    LimitInner.put("Skip", 0L);
                    LimitInner.put("Count", 1440L);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "ce_computelog", CriteriaInner, null, LimitInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                        Entity_ce_computelog entity = (Entity_ce_computelog) FastJsonUtil.To_JavaObject(computelog, Entity_ce_computelog.class);
                        if (entity.is_finished == 1) {
                            Entity_ces_log log = new Entity_ces_log();
                            log.compute_round = entity.compute_round;
                            log.compute_time_from = entity.compute_time_from;
                            log.compute_time_to = entity.compute_time_to;
                            logList.add(log);
                        }
                    }
                }

                if (logList.size() > 0) {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("object_sign", source_object_sign);
                    CriteriaInner.put("instance_name", source_instance_name);
                    JSONObject range = new JSONObject();
                    range.put("$gte", logList.get(0).compute_round);
                    range.put("$lte", logList.get(logList.size() - 1).compute_round);
                    CriteriaInner.put("compute_round", range);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "ce_computeoutputdetail", CriteriaInner);
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject computedetail = (JSONObject) resultContentInner.get(ii);
                        String output_sign = (String) computedetail.get("output_sign");
                        if (outputMap.containsKey(output_sign)) {
                            Entity_ce_computeoutputdetail entity = (Entity_ce_computeoutputdetail) FastJsonUtil.To_JavaObject(computedetail,
                                    Entity_ce_computeoutputdetail.class);
                            Entity_ces_detail detail = new Entity_ces_detail();
                            detail.compute_round = entity.compute_round;
                            detail.output_sign = entity.output_sign;
                            detail.valid_time_from = entity.valid_time_from;
                            detail.valid_time_to = entity.valid_time_to;
                            detailList.add(detail);
                        }
                    }
                }
            }

            logLists[i] = logList;
            detailLists[i] = detailList;
        }
        for (int i = 0; i < all_bags.length; i++) {
            List<?> logList = logLists[i];
            log_usedss[i] = new int[logList.size()];
        }

        // 重算recompute先摘出来
        for (int i = 0; i < logLists.length; i++) {
            List<?> logList = logLists[i];
            List<?> detailList = detailLists[i];
            CoreOutputBag bag = all_bags[i];
            String source_object_sign = bag.source_object_sign;
            String source_instance_name = bag.source_instance_name;
            int[] log_useds = log_usedss[i];
            for (int ii = 0; ii < logList.size(); ii++) {
                if (log_useds[ii] != 0) {
                    continue;
                }

                Entity_ces_log log = (Entity_ces_log) logList.get(ii);
                if (log.is_recompute == 1L) {
                    Date time_from_real = log.compute_time_from;
                    Date time_to_real = log.compute_time_to;
                    Entitys_ce_compute fjd_postcompute = new Entitys_ce_compute();
                    fjd_postcompute.log = new Entity_ce_computelog();
                    fjd_postcompute.log.object_sign = object_sign;
                    fjd_postcompute.log.instance_name = instance_name;
                    fjd_postcompute.log.is_finished = 0L;
                    List<Entity_ce_computeinputlog> inputlogList = new ArrayList<Entity_ce_computeinputlog>();
                    Map<String, List<TimeSpan>> timeSpanListMap = new HashMap<String, List<TimeSpan>>();

                    Entity_ces_log logInner = log;
                    if (time_from_real.getTime() > logInner.compute_time_from.getTime()) {
                        time_from_real = logInner.compute_time_from;
                    }
                    if (time_to_real.getTime() < logInner.compute_time_to.getTime()) {
                        time_to_real = logInner.compute_time_to;
                    }
                    Entity_ce_computeinputlog exist_inputlog = null;
                    if (exist_inputlog == null) {
                        exist_inputlog = new Entity_ce_computeinputlog();
                        exist_inputlog.object_sign = object_sign;
                        exist_inputlog.instance_name = instance_name;
                        exist_inputlog.source_object_sign = source_object_sign;
                        exist_inputlog.source_instance_name = source_instance_name;
                        exist_inputlog.compute_rounds = "";
                        inputlogList.add(exist_inputlog);
                    }
                    if (exist_inputlog.compute_rounds.length() == 0) {
                        exist_inputlog.compute_rounds += "" + logInner.compute_round;
                    } else {
                        exist_inputlog.compute_rounds += "," + logInner.compute_round;
                    }
                    for (Object obj : detailList) {
                        Entity_ces_detail detail = (Entity_ces_detail) obj;
                        if (detail.compute_round == logInner.compute_round) {
                            Map<String, CoreInput> outputMapInner = bag.outputMap;
                            CoreInput input = outputMapInner.get(detail.output_sign);
                            if (!timeSpanListMap.containsKey(input.input_sign)) {
                                timeSpanListMap.put(input.input_sign, new ArrayList<TimeSpan>());
                            }
                            List<TimeSpan> timeSpanList = timeSpanListMap.get(input.input_sign);
                            DateUtil.Instance().Merge(timeSpanList, detail.valid_time_from, detail.valid_time_to, input.time_period);
                        }
                    }

                    fjd_postcompute.log.compute_time_from = time_from_real;
                    fjd_postcompute.log.compute_time_to = time_to_real;
                    fjd_postcompute.inputlogList = inputlogList;
                    fjd_postcompute.inputdetailListMap = timeSpanListMap;
                    postcomputeList_recompute.add(fjd_postcompute);

                    log_useds[ii] = 1;
                }
            }
        }

        for (int i = 0; i < logLists.length; i++) {
            List<?> logList = logLists[i];
            int[] log_useds = log_usedss[i];
            for (int ii = 0; ii < logList.size(); ii++) {
                if (log_useds[ii] != 0) {
                    continue;
                }

                Entity_ces_log log = (Entity_ces_log) logList.get(ii);
                Date base_time = log.compute_time_from;
                Date time_from_real = log.compute_time_from;
                Date time_to_real = log.compute_time_to;
                Entitys_ce_compute fjd_postcompute = new Entitys_ce_compute();
                fjd_postcompute.log = new Entity_ce_computelog();
                fjd_postcompute.log.object_sign = object_sign;
                fjd_postcompute.log.instance_name = instance_name;
                fjd_postcompute.log.is_finished = 0L;
                List<Entity_ce_computeinputlog> inputlogList = new ArrayList<Entity_ce_computeinputlog>();
                Map<String, List<TimeSpan>> timeSpanListMap = new HashMap<String, List<TimeSpan>>();

                for (int k = i; k < logLists.length; k++) {
                    List<?> logListInner = logLists[k];
                    List<?> detailListInner = detailLists[k];
                    String source_object_sign = all_bags[k].source_object_sign;
                    String source_instance_name = all_bags[k].source_instance_name;
                    int[] log_usedsInner = log_usedss[k];
                    for (int kk = 0; kk < logListInner.size(); kk++) {
                        if (k == i && kk < ii) {
                            continue;
                        }
                        if (log_usedsInner[kk] != 0) {
                            continue;
                        }
                        Entity_ces_log logInner = (Entity_ces_log) logListInner.get(kk);
                        if ((base_time.getTime() - 1000L * 60 * 60 * 24 * 3 <= logInner.compute_time_from.getTime()
                                && logInner.compute_time_from.getTime() <= base_time.getTime() + 1000L * 60 * 60 * 24 * 3)
                                || (logInner.compute_time_from.getTime() >= time_from_real.getTime()
                                && logInner.compute_time_to.getTime() <= time_to_real.getTime())) {
                            log_usedsInner[kk] = 1;
                            if (time_from_real.getTime() > logInner.compute_time_from.getTime()) {
                                time_from_real = logInner.compute_time_from;
                            }
                            if (time_to_real.getTime() < logInner.compute_time_to.getTime()) {
                                time_to_real = logInner.compute_time_to;
                            }
                            Entity_ce_computeinputlog exist_inputlog = null;
                            for (Entity_ce_computeinputlog inputlog : inputlogList) {
                                if (inputlog.source_object_sign.equals(source_object_sign)
                                        && inputlog.source_instance_name.equals(source_instance_name)) {
                                    exist_inputlog = inputlog;
                                    break;
                                }
                            }
                            if (exist_inputlog == null) {
                                exist_inputlog = new Entity_ce_computeinputlog();
                                exist_inputlog.object_sign = object_sign;
                                exist_inputlog.instance_name = instance_name;
                                exist_inputlog.source_object_sign = source_object_sign;
                                exist_inputlog.source_instance_name = source_instance_name;
                                exist_inputlog.compute_rounds = "";
                                inputlogList.add(exist_inputlog);
                            }
                            if (exist_inputlog.compute_rounds.length() == 0) {
                                exist_inputlog.compute_rounds += "" + logInner.compute_round;
                            } else {
                                exist_inputlog.compute_rounds += "," + logInner.compute_round;
                            }
                            for (Object obj : detailListInner) {
                                Entity_ces_detail detail = (Entity_ces_detail) obj;
                                if (detail.compute_round == logInner.compute_round) {
                                    Map<String, CoreInput> outputMapInner = all_bags[k].outputMap;
                                    CoreInput input = outputMapInner.get(detail.output_sign);
                                    if (!timeSpanListMap.containsKey(input.input_sign)) {
                                        timeSpanListMap.put(input.input_sign, new ArrayList<TimeSpan>());
                                    }
                                    List<TimeSpan> timeSpanList = timeSpanListMap.get(input.input_sign);
                                    DateUtil.Instance().Merge(timeSpanList, detail.valid_time_from, detail.valid_time_to, input.time_period);
                                }
                            }
                        }
                    }
                }

                fjd_postcompute.log.compute_time_from = time_from_real;
                fjd_postcompute.log.compute_time_to = time_to_real;
                fjd_postcompute.inputlogList = inputlogList;
                fjd_postcompute.inputdetailListMap = timeSpanListMap;

                int insert_index = 0;
                for (int k = 0; k < postcomputeList.size(); k++) {
                    Entitys_ce_compute fjd_postcompute_tmp = postcomputeList.get(k);
                    int cmp_from = fjd_postcompute_tmp.log.compute_time_from.compareTo(fjd_postcompute.log.compute_time_from);
                    int cmp_to = fjd_postcompute_tmp.log.compute_time_to.compareTo(fjd_postcompute.log.compute_time_to);
                    if (cmp_from < 0) {
                        insert_index = k + 1;
                    } else if (cmp_from == 0) {
                        if (cmp_to < 0) {
                            insert_index = k + 1;
                        } else {
                            insert_index = k;
                            break;
                        }
                    } else {
                        insert_index = k;
                        break;
                    }
                }
                postcomputeList.add(insert_index, fjd_postcompute);
            }
        }

        postcomputeList.addAll(postcomputeList_recompute);
        Generate_round(database_name, object_sign, instance_name, curround + postcomputeList.size());
        for (int ii = 0; ii < postcomputeList.size(); ii++) {
            Entitys_ce_compute fjd_postcompute = postcomputeList.get(ii);
            long compute_round = curround + 1 + ii;
            fjd_postcompute.log.compute_round = compute_round;
            for (Entity_ce_computeinputlog input : fjd_postcompute.inputlogList) {
                input.compute_round = compute_round;
            }
            Insert_ce_compute(database_name, fjd_postcompute);
        }

        for (int k = 0; k < logLists.length; k++) {
            long exist_round = exist_rounds[k];
            long current_round = exist_round;
            List<?> logList = logLists[k];
            if (logList.size() > 0) {
                Entity_ces_log entity = (Entity_ces_log) logList.get(logList.size() - 1);
                current_round = entity.compute_round;
            }

            String source_object_sign = all_bags[k].source_object_sign;
            String source_instance_name = all_bags[k].source_instance_name;
            if (exist_round == 0) {
                if (current_round != exist_round) {
                    JSONObject InsertObject = new JSONObject();
                    InsertObject.put("object_sign", object_sign);
                    InsertObject.put("instance_name", instance_name);
                    InsertObject.put("source_object_sign", source_object_sign);
                    InsertObject.put("source_instance_name", source_instance_name);
                    InsertObject.put("compute_round", current_round);
                    QueryUtil.insert(database_name, "ce_preroundindex", InsertObject);
                }
            } else {
                if (current_round != exist_round) {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("object_sign", object_sign);
                    CriteriaInner.put("instance_name", instance_name);
                    CriteriaInner.put("source_object_sign", source_object_sign);
                    CriteriaInner.put("source_instance_name", source_instance_name);
                    JSONObject Set = new JSONObject();
                    Set.put("compute_round", current_round);
                    QueryUtil.update(database_name, "ce_preroundindex", CriteriaInner, Set);
                }
            }
        }

        return postcomputeList;
    }

    private static void Insert_ce_compute(String database_name, Entitys_ce_compute fjd_postcompute) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        for (Entity_ce_computeinputlog input : fjd_postcompute.inputlogList) {
            JSONObject InsertObject = (JSONObject) FastJsonUtil.To_JSON(input);
            QueryUtil.insert(database_name, "ce_computeinputlog", InsertObject);
        }
        for (String input_sign : fjd_postcompute.inputdetailListMap.keySet()) {
            List<TimeSpan> timeSpanList = fjd_postcompute.inputdetailListMap.get(input_sign);
            for (TimeSpan timeSpan : timeSpanList) {
                JSONObject InsertObject = new JSONObject();
                InsertObject.put("object_sign", fjd_postcompute.log.object_sign);
                InsertObject.put("instance_name", fjd_postcompute.log.instance_name);
                InsertObject.put("compute_round", fjd_postcompute.log.compute_round);
                InsertObject.put("input_sign", input_sign);
                InsertObject.put("valid_time_from", sdf.format(timeSpan.timefrom));
                InsertObject.put("valid_time_to", sdf.format(timeSpan.timeto));
                QueryUtil.insert(database_name, "ce_computeinputdetail", InsertObject);
            }
        }
        {
            JSONObject InsertObject = (JSONObject) FastJsonUtil.To_JSON(fjd_postcompute.log);
            InsertObject.put("operate_time_from", sdf.format(new Date()));
            QueryUtil.insert(database_name, "ce_computelog", InsertObject);
        }
    }

    private static void Generate_round(String database_name, String object_sign, String instance_name, Long round_new)
            throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONArray resultContent = QueryUtil.select(database_name, "ce_curround", Criteria);
        long compute_round;
        if (round_new == null) {
            long exist = 0;
            if (resultContent.size() > 0) {
                JSONObject roundmax = (JSONObject) resultContent.get(0);
                exist = (Long) roundmax.get("compute_round");
            }
            compute_round = exist + 1;
        } else {
            compute_round = round_new;
        }

        if (resultContent.size() > 0) {
            JSONObject Set = new JSONObject();
            Set.put("compute_round", compute_round);
            QueryUtil.update(database_name, "ce_curround", Criteria, Set);
        } else {
            JSONObject InsertObject = new JSONObject();
            InsertObject.put("object_sign", object_sign);
            InsertObject.put("instance_name", instance_name);
            InsertObject.put("compute_round", compute_round);
            QueryUtil.insert(database_name, "ce_curround", InsertObject);
        }
    }

    public static boolean ComputeAndSave(String database_name, CoreInstance instance, IDao_log dao_log) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String object_sign = instance.object_sign;
        String instance_name = instance.instance_name;

        Entitys_ce_compute postcompute = ComputeEngineUtil.Begin(database_name, object_sign, instance_name, instance.inputList);
        if (postcompute == null) {
            String status_current = "start_idle";

            String name = object_sign + "_" + instance_name;
            ZKWrapper ZK = HBaseSaveManagerRepository.randomZillionAgent().container.ZK;
            Stat stat = ZK.exists(ConstantCE.zk_status_current + "/" + name, false);
            if (stat != null) {
                stat = new Stat();
                byte[] databytes = ZK.getData(ConstantCE.zk_status_current + "/" + name, false, stat);
                String dataString = ByteToObject.toString(databytes);
                if (dataString.equals(status_current)) {
                    return false;
                }
            }

            ZKSyncUtil.Sync(ZK, ConstantCE.zk_status_current + "/" + name, status_current);
            StatusUtil.Sync_status_current(database_name, object_sign, instance_name, status_current);
            return false;
        }

        {
            String status_current = "start_running";
            StatusUtil.Sync_status_current(database_name, object_sign, instance_name, status_current);
        }
        InstanceUtil.Update_compute_round(database_name, object_sign, instance_name, postcompute.log.compute_round);

        log.warn(object_sign + "_" + instance_name + " " + postcompute.log.compute_round + " " + sdf.format(postcompute.log.compute_time_from)
                + "~" + sdf.format(postcompute.log.compute_time_to) + "\t" + "Compute begin");
        Map<String, List<TimeSpan>> outputTimeSpanMap = new ConcurrentHashMap<String, List<TimeSpan>>();
        if (instance_name.startsWith("fjd_0") || instance_name.startsWith("fjd_1") || "stat_Inst".equals(instance_name)
                || "servicedata".equals(instance_name) || "servicedata_max".equals(instance_name) || "servicedata_stat".equals(instance_name)
                || "servicedataoftenant".equals(instance_name) || "servicedataoftenant_max".equals(instance_name)
                || "servicedataoftenant_stat".equals(instance_name) || "tenant_max".equals(instance_name) || "tenant_stat".equals(instance_name)
                || "stat_Inst_stat".equals(instance_name) || "EMS_max".equals(instance_name) || "EMS_stat".equals(instance_name)) {
            if ("servicedata_max".equals(instance_name) || "servicedataoftenant_max".equals(instance_name) || "servicedata_stat".equals(instance_name)
                    || "servicedataoftenant_stat".equals(instance_name) || "tenant_stat".equals(instance_name)
                    || "stat_Inst_stat".equals(instance_name) || "EMS_max".equals(instance_name) || "EMS_stat".equals(instance_name)) {
                CoreComputeUtilUtil.BuildNetwork(instance);
            }
            if (ConstantCE.job_split) {
                ComputeJob ComputeJob = new ComputeJob();
                ComputeJob.object_sign = object_sign;
                ComputeJob.instance_name = instance_name;
                ComputeJob.inputList = instance.inputList;
                ComputeJob.outputList = instance.outputList;
                ComputeJob.compute_round = postcompute.log.compute_round;
                ComputeJob.compute_time_from = postcompute.log.compute_time_from;
                ComputeJob.compute_time_to = postcompute.log.compute_time_to;
                ComputeJob.inputdetailListMap = postcompute.inputdetailListMap;
                ComputeJob.outputdetailListMap = postcompute.outputdetailListMap;
                ComputeJob.dao_log = dao_log;
                ComputeJob.outputTimeSpanMap = outputTimeSpanMap;
                ComputeJobRepository.Instance().AddComputeJob(ComputeJob);
                while (true) {
                    Thread.sleep(1000L);
                    if (ComputeJob.finish_count == ComputeJob.inputList.size()) {
                        break;
                    }
                }
                ComputeJobRepository.Instance().RemoveComputeJob(ComputeJob);
                if (ComputeJob.finish_error) {
                    throw new Exception(ComputeJob.object_sign + "\t" + ComputeJob.instance_name + "\t" + "finish with error");
                }
            } else {
                if (instance_name.startsWith("fjd_0")) {
                    Compute_fjd_0.Compute(object_sign, instance_name, instance.inputList, instance.outputList, postcompute.log.compute_round,
                            postcompute.inputdetailListMap, postcompute.outputdetailListMap, postcompute.log.compute_time_from,
                            postcompute.log.compute_time_to, dao_log);
                } else if (instance_name.startsWith("fjd_1")) {
                    Compute_fjd_1.Compute(object_sign, instance_name, instance.inputList, instance.outputList, postcompute.log.compute_round,
                            postcompute.inputdetailListMap, postcompute.outputdetailListMap, dao_log);
                } else if ("stat_Inst".equals(instance_name)) {
                    Compute_stat_Inst.Compute(object_sign, instance_name, instance.inputList, instance.outputList, postcompute.log.compute_round,
                            postcompute.inputdetailListMap, postcompute.outputdetailListMap, dao_log);
                } else if ("servicedata".equals(instance_name) || "servicedataoftenant".equals(instance_name)) {
                    Compute_servicedata.Compute(object_sign, instance_name, instance.inputList, instance.outputList, postcompute.log.compute_round,
                            postcompute.inputdetailListMap, postcompute.outputdetailListMap, dao_log);
                } else if ("servicedata_max".equals(instance_name) || "servicedataoftenant_max".equals(instance_name)
                        || "servicedata_stat".equals(instance_name) || "servicedataoftenant_stat".equals(instance_name)
                        || "tenant_max".equals(instance_name) || "tenant_stat".equals(instance_name) || "stat_Inst_stat".equals(instance_name)) {
                    outputTimeSpanMap = CoreComputeUtil.ComputeOnce(object_sign, instance_name, instance.inputList, instance.outputList,
                            postcompute.log.compute_round, postcompute.inputdetailListMap, postcompute.outputdetailListMap, dao_log, true);
                }
            }
        } else if ("EMS".equals(instance_name)) {
            CoreComputeUtilUtil.BuildNetwork(instance);
            for (CoreInput input : instance.inputList) {
                if ("servicedata_virtualpoint_99999".equals(input.input_sign)) {
                    long tmp_interval = DateUtil.Instance().get_about(input.time_period);
                    List<TimeSpan> ts_virtual = new ArrayList<TimeSpan>();
                    ts_virtual.add(new TimeSpan(new Date(postcompute.log.compute_time_from.getTime() - tmp_interval),
                            new Date(postcompute.log.compute_time_to.getTime() - tmp_interval)));
                    postcompute.inputdetailListMap.put(input.input_sign, ts_virtual);
                }
            }
            outputTimeSpanMap = CoreComputeUtil.ComputeByPart(object_sign, instance_name, instance.inputList, instance.outputList,
                    postcompute.log.compute_round, postcompute.inputdetailListMap, postcompute.outputdetailListMap, dao_log);
        } else {
            CoreComputeUtilUtil.BuildNetwork(instance);
            outputTimeSpanMap = CoreComputeUtil.ComputeOnce(object_sign, instance_name, instance.inputList, instance.outputList,
                    postcompute.log.compute_round, postcompute.inputdetailListMap, postcompute.outputdetailListMap, dao_log, true);
        }
        log.warn(object_sign + "_" + instance_name + " " + postcompute.log.compute_round + " " + sdf.format(postcompute.log.compute_time_from)
                + "~" + sdf.format(postcompute.log.compute_time_to) + "\t" + "Compute end");

        if (instance_name.startsWith("fjd_0")) {
            // finish
            JSONObject Criteria = new JSONObject();
            Criteria.put("building", object_sign);
            Criteria.put("compute_round", postcompute.log.compute_round);
            JSONObject Set = new JSONObject();
            Set.put("is_finished", 1L);
            Set.put("operate_time_to", sdf.format(new Date()));
            QueryUtil.update(database_name, "fjd_0_computelog", Criteria, Set);

            if (postcompute.is_recompute != 1L) {
                // fjd_0_buildingcomputetime
                Criteria = new JSONObject();
                Criteria.put("building", object_sign);
                Set = new JSONObject();
                Set.put("compute_time", sdf.format(postcompute.log.compute_time_to));
                QueryUtil.update(database_name, "fjd_0_buildingcomputetime", Criteria, Set);
            }
        } else if (instance_name.startsWith("fjd_1")) {
            // finish
            JSONObject Criteria = new JSONObject();
            Criteria.put("building", object_sign);
            Criteria.put("compute_round", postcompute.log.compute_round);
            JSONObject Set = new JSONObject();
            Set.put("is_finished", 1L);
            Set.put("operate_time_to", sdf.format(new Date()));
            QueryUtil.update(database_name, "fjd_1_computelog", Criteria, Set);
        } else {
            // finish
            JSONObject Criteria = new JSONObject();
            Criteria.put("object_sign", object_sign);
            Criteria.put("instance_name", instance_name);
            Criteria.put("compute_round", postcompute.log.compute_round);
            JSONObject Set = new JSONObject();
            Set.put("is_finished", 1L);
            Set.put("operate_time_to", sdf.format(new Date()));
            QueryUtil.update(database_name, "ce_computelog", Criteria, Set);
        }

        {
            String status_current = "start_rest";
            StatusUtil.Sync_status_current(database_name, object_sign, instance_name, status_current);
        }

        return true;
    }
}
