package com.sagacloud.util.compute_engine.fjd;

import com.sagacloud.util.compute_engine.core.CoreInput;
import com.sagacloud.util.compute_engine.core.CoreOutput;
import com.sagacloud.util.compute_engine.util.ConstantCE;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ComputeJobRepository {
    private static final ComputeJobRepository instance = new ComputeJobRepository();
    private final List<String> JobList = new ArrayList<String>();
    private final Map<String, ComputeJob> JobMap = new HashMap<String, ComputeJob>();

    private ComputeJobRepository() {

    }

    public static ComputeJobRepository Instance() {
        return instance;
    }

    public synchronized boolean AddComputeJob(ComputeJob ComputeJob) {
        String real_sign = "[" + ComputeJob.object_sign + "]" + "_" + "[" + ComputeJob.instance_name + "]";
        if (JobMap.containsKey(real_sign)) {
            return false;
        }
        JobList.add(real_sign);
        JobMap.put(real_sign, ComputeJob);
        return true;
    }

    public synchronized boolean RemoveComputeJob(ComputeJob ComputeJob) {
        String real_sign = "[" + ComputeJob.object_sign + "]" + "_" + "[" + ComputeJob.instance_name + "]";
        if (!JobMap.containsKey(real_sign)) {
            return false;
        }

        int index = -1;
        for (int i = 0; i < JobList.size(); i++) {
            String real_signInner = JobList.get(i);
            if (real_signInner.equals(real_sign)) {
                index = i;
                break;
            }
        }
        JobList.remove(index);
        JobMap.remove(real_sign);
        return true;
    }

    public synchronized ComputeJobItem Pop() {
        ComputeJobItem result = null;

        ComputeJob ComputeJob = null;
        for (int i = 0; i < JobList.size(); i++) {
            String real_signInner = JobList.get(i);
            ComputeJob ComputeJobInner = JobMap.get(real_signInner);
            if (ComputeJobInner.pop_count < ComputeJobInner.inputList.size()) {
                ComputeJob = ComputeJobInner;
                break;
            }
        }
        if (ComputeJob != null) {
            result = new ComputeJobItem();
            result.object_sign = ComputeJob.object_sign;
            result.instance_name = ComputeJob.instance_name;
            result.inputList = new ArrayList<CoreInput>();
            result.outputList = new ArrayList<CoreOutput>();
            result.compute_round = ComputeJob.compute_round;
            result.compute_time_from = ComputeJob.compute_time_from;
            result.compute_time_to = ComputeJob.compute_time_to;
            result.inputdetailListMap = ComputeJob.inputdetailListMap;
            result.outputdetailListMap = ComputeJob.outputdetailListMap;
            result.dao_log = ComputeJob.dao_log;
            result.outputTimeSpanMap = ComputeJob.outputTimeSpanMap;

            int pop_count = ComputeJob.pop_count;
            for (int i = pop_count; i < ComputeJob.inputList.size() && i < pop_count + ConstantCE.job_batch_count; i++) {
                result.inputList.add(ComputeJob.inputList.get(i));
                result.outputList.add(ComputeJob.outputList.get(i));
                ComputeJob.pop_count++;
            }
        }

        return result;
    }

    public synchronized void Finish(ComputeJobItem ComputeJobItem) {
        String real_sign = "[" + ComputeJobItem.object_sign + "]" + "_" + "[" + ComputeJobItem.instance_name + "]";
        if (!JobMap.containsKey(real_sign)) {
            return;
        }
        ComputeJob ComputeJob = JobMap.get(real_sign);
        ComputeJob.finish_count += ComputeJobItem.inputList.size();
    }

    public synchronized void FinishWithError(ComputeJobItem ComputeJobItem) {
        String real_sign = "[" + ComputeJobItem.object_sign + "]" + "_" + "[" + ComputeJobItem.instance_name + "]";
        if (!JobMap.containsKey(real_sign)) {
            return;
        }
        ComputeJob ComputeJob = JobMap.get(real_sign);
        ComputeJob.finish_error = true;
        ComputeJob.finish_count += ComputeJobItem.inputList.size();
    }
}
