package com.sagacloud.util.compute_engine.fjd;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.core.CoreInput;
import com.sagacloud.util.compute_engine.core.CoreInstance;
import com.sagacloud.util.compute_engine.core.CoreOutput;
import com.sagacloud.util.compute_engine.entity.*;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonReaderUtil;
import org.zillion.util.json.FastJsonUtil;

import java.util.*;
@Slf4j
public class TenantUtil {
    public static List<Long> get_funcid(String energy_type, String price_type, Map<String, Entity_point> pointMap,
                                        Entity_tenant_energy_meter detail) {
        List<Long> result = new ArrayList<Long>();
        if ("Dian".equals(energy_type)) {
            if ("time_price".equals(price_type)) {
                long[] funcids = {10708L, 10705L, 10707L, 10706L};
                for (long funcid : funcids) {
                    if (!pointMap.containsKey(detail.getMeter_sign() + "_" + funcid)) {
                        continue;
                    }
                    result.add(funcid);
                }
            } else {
                result.add(10101L);
            }
        } else if ("Shui".equals(energy_type)) {
            result.add(12106L);
        } else if ("RanQi".equals(energy_type)) {
            result.add(13502L);
        } else if ("Leng".equals(energy_type)) {
            result.add(12106L);
        }
        return result;
    }

    public static List<String> get_price() {
        List<String> result = new ArrayList<String>();
        result.add("J");
        result.add("F");
        result.add("G");
        result.add("P");
        return result;
    }

    @SuppressWarnings("unused")
    public static void buildInstance(String database_name, JSONObject Criteria, CoreInstance instance,
                                     Map<String, Entity_point> pointMap) throws Exception {
        String object_sign = instance.object_sign;
        String instance_name = instance.instance_name;
        String building = instance.object_sign;

        JSONArray content_tenant = QueryUtil.select(database_name, "tenant", Criteria);
        JSONArray content_tenant_energy = QueryUtil.select(database_name, "tenant_energy", Criteria);
        JSONArray content_tenant_energy_meter = QueryUtil.select(database_name, "tenant_energy_meter", Criteria);
        JSONArray content_tenant_energy_price = QueryUtil.select(database_name, "tenant_energy_price", Criteria);
        Map<String, Entity_tenant> tenantMap = new HashMap<String, Entity_tenant>();
        for (int i = 0; i < content_tenant.size(); i++) {
            JSONObject json = (JSONObject) content_tenant.get(i);
            Entity_tenant detail = (Entity_tenant) FastJsonUtil.To_JavaObject(json, Entity_tenant.class);
            tenantMap.put(detail.getSign(), detail);
        }
        for (int i = 0; i < content_tenant_energy.size(); i++) {
            JSONObject json = (JSONObject) content_tenant_energy.get(i);
            Entity_tenant_energy detail = (Entity_tenant_energy) FastJsonUtil.To_JavaObject(json, Entity_tenant_energy.class);
            tenantMap.get(detail.getSign()).energyMap.put(detail.getEnergy_type(), detail);
        }
        for (int i = 0; i < content_tenant_energy_price.size(); i++) {
            JSONObject json = (JSONObject) content_tenant_energy_price.get(i);
            Entity_tenant_energy_price detail = (Entity_tenant_energy_price) FastJsonUtil.To_JavaObject(json, Entity_tenant_energy_price.class);
            try {
                detail.priceObject = Double.parseDouble(detail.getPrice_content());
            } catch (Exception e) {
                detail.priceObject = FastJsonReaderUtil.Instance().parse(detail.getPrice_content());
            }
            Entity_tenant_energy energy = tenantMap.get(detail.getSign()).energyMap.get(detail.getEnergy_type());
            energy.priceList.add(detail);
        }
        for (int i = 0; i < content_tenant_energy_meter.size(); i++) {
            JSONObject json = (JSONObject) content_tenant_energy_meter.get(i);
            Entity_tenant_energy_meter detail = (Entity_tenant_energy_meter) FastJsonUtil.To_JavaObject(json, Entity_tenant_energy_meter.class);
            Entity_tenant tenant = tenantMap.get(detail.getSign());
            Entity_tenant_energy energy = tenant.energyMap.get(detail.getEnergy_type());
            energy.meterMap.put(detail.getMeter_sign(), detail);
        }
        Map<String, Entity_ci_instanceinput> inputMap = new HashMap<String, Entity_ci_instanceinput>();
        List<CoreOutput> meterdataList = new ArrayList<CoreOutput>();
        List<CoreOutput> meterfeeList = new ArrayList<CoreOutput>();
        List<CoreOutput> typedataList = new ArrayList<CoreOutput>();
        List<CoreOutput> typefeeList = new ArrayList<CoreOutput>();
        List<CoreOutput> feeList = new ArrayList<CoreOutput>();

        Map<String, List<String>> totalTypeEnergyMap = new HashMap<String, List<String>>();
        Map<String, List<String>> totalTypeFeeMap = new HashMap<String, List<String>>();

        String first_time_begin = null;
        Iterator<String> tenantIter = tenantMap.keySet().iterator();
        while (tenantIter.hasNext()) {
            String key_tenant = tenantIter.next();
            Entity_tenant tenant = tenantMap.get(key_tenant);
            String time_begin = tenant.getValid_time_from();
            String time_end = tenant.getValid_time_to() == null ? "99990101000000" : tenant.getValid_time_to();
            if (first_time_begin == null || first_time_begin.compareTo(time_begin) > 0) {
                first_time_begin = time_begin;
            }

            Map<String, Object> otherMap = new HashMap<String, Object>();
            Map<String, List<Entity_tenant_energy_price>> priceListMap = new HashMap<String, List<Entity_tenant_energy_price>>();
            Iterator<String> energyIter = tenant.energyMap.keySet().iterator();
            while (energyIter.hasNext()) {
                String key_energy = energyIter.next();
                Entity_tenant_energy energy = tenant.energyMap.get(key_energy);
                priceListMap.put(energy.getEnergy_type(), energy.priceList);
            }
            otherMap.put("priceListMap", priceListMap);

            Entity_ci_instanceoutput output_fee;
            {
                Entity_ci_instanceoutput output = new Entity_ci_instanceoutput();
                output.setObject_sign(object_sign);
                output.setInstance_name(instance_name);
                output.setOutput_sign("tenantfee" + "_" + tenant.getSign());
                output.setTime_begin(time_begin);
                output.setTime_end(time_end);
                output.setData_class("consumption");
                output.setDao_type("tenantfee");
                JSONObject dao_key = new JSONObject();
                dao_key.put("building", building);
                dao_key.put("tenant", tenant.getSign());
                dao_key.put("energy_type", null);
                dao_key.put("meter_sign", null);
                dao_key.put("funcid", null);
                output.setDao_key(FastJsonUtil.toString(dao_key));
                output.setNeed_all_var_data(false);
                output.setTime_period_intialized(false);
                output.setTime_period("15min");
                output.setMode("custom");
                output.setCustom_function_name("custom_add");
                output.setOtherMap(otherMap);
                output_fee = output;
            }
            CoreOutput CoreOutput_fee = CoreInstance.Convert_output(output_fee);
            if (tenant.getSoft_enable()) {
                CoreOutput_fee.other_type = "tenant_ruanchongruankou";
            }
            feeList.add(CoreOutput_fee);
            List<String> fee_expression = new ArrayList<String>();

            energyIter = tenant.energyMap.keySet().iterator();
            while (energyIter.hasNext()) {
                String key_energy = energyIter.next();
                Entity_tenant_energy energy = tenant.energyMap.get(key_energy);

                Entity_ci_instanceoutput output_typedata;
                {
                    Entity_ci_instanceoutput output = new Entity_ci_instanceoutput();
                    output.setObject_sign(object_sign);
                    output.setInstance_name(instance_name);
                    output.setOutput_sign("tenantdata" + "_" + tenant.getSign() + "_" + energy.getEnergy_type());
                    output.setTime_begin(time_begin);
                    output.setTime_end(time_end);
                    output.setData_class("consumption");
                    output.setDao_type("tenantdata");
                    JSONObject dao_key = new JSONObject();
                    dao_key.put("building", building);
                    dao_key.put("tenant", tenant.getSign());
                    dao_key.put("energy_type", energy.getEnergy_type());
                    dao_key.put("meter_sign", null);
                    dao_key.put("funcid", null);
                    output.setDao_key(FastJsonUtil.toString(dao_key));
                    output.setNeed_all_var_data(false);
                    output.setTime_period_intialized(false);
                    output.setTime_period("15min");
                    output.setMode("custom");
                    output.setCustom_function_name("custom_add");
                    output.setOtherMap(otherMap);
                    output_typedata = output;
                }
                CoreOutput CoreOutput_typedata = CoreInstance.Convert_output(output_typedata);
                CoreOutput CoreOutput_typefee = CoreInstance.Convert_output(output_typedata);
                CoreOutput_typefee.output_sign = "tenantfee" + "_" + output_typedata.getOutput_sign().substring("tenantdata".length() + 1);
                CoreOutput_typefee.dao_type = "tenantfee";
                if (energy.getSoft_enable()) {
                    CoreOutput_typefee.other_type = "tenant_ruanchongruankou";
                }
                typedataList.add(CoreOutput_typedata);
                typefeeList.add(CoreOutput_typefee);
                List<String> typedata_expression = new ArrayList<String>();
                List<String> typefee_expression = new ArrayList<String>();

                List<String> time_priceNameList = TenantUtil.get_price();
                Iterator<String> meterIter = energy.meterMap.keySet().iterator();
                while (meterIter.hasNext()) {
                    String key_meter = meterIter.next();
                    Entity_tenant_energy_meter detail = energy.meterMap.get(key_meter);
                    List<Long> funcidList = TenantUtil.get_funcid(energy.getEnergy_type(), energy.getPrice_type(), pointMap, detail);
                    for (long funcid : funcidList) {
                        if (inputMap.containsKey(detail.getMeter_sign() + "_" + funcid)) {
                            continue;
                        }
                        if(!pointMap.containsKey(detail.getMeter_sign() + "_" + funcid)){
                            log.error("[dy_pointlist]没有要计算的meter[{}] funcid[{}],Entity_tenant_energy_meter详情:[{}]",detail.getMeter_sign(),funcid, JSON.toJSONString(detail));
                            continue;
                        }
                        Entity_ci_instanceinput input = new Entity_ci_instanceinput();
                        input.setObject_sign(object_sign);
                        input.setInstance_name(instance_name);
                        input.setInput_sign("servicedata_" + detail.getMeter_sign() + "_" + funcid);
                        input.setTime_period(pointMap.get(detail.getMeter_sign() + "_" + funcid).collect_cycle);
                        input.setData_class("consumption");
                        input.setDao_type("servicedata");
                        JSONObject dao_key = new JSONObject();
                        dao_key.put("building", building);
                        dao_key.put("meter", detail.getMeter_sign());
                        dao_key.put("funcid", funcid);
                        input.setDao_key(FastJsonUtil.toString(dao_key));
                        input.setSource_object_sign(building);
                        input.setSource_instance_name("servicedataoftenant");
                        input.setSource_output_sign("servicedata_" + detail.getMeter_sign() + "_" + funcid);
                        CoreInput CoreInput = CoreInstance.Convert_input(input);
                        instance.inputList.add(CoreInput);
                        inputMap.put(detail.getMeter_sign() + "_" + funcid, input);
                    }

                    Entity_ci_instanceoutput output_meter;
                    {
                        Entity_ci_instanceoutput output = new Entity_ci_instanceoutput();
                        output.setObject_sign(object_sign);
                        output.setInstance_name(instance_name);
                        output.setOutput_sign("tenantdata" + "_" + tenant.getSign() + "_" + energy.getEnergy_type() + "_" + detail.getMeter_sign());
                        output.setTime_begin(time_begin);
                        output.setTime_end(time_end);
                        output.setData_class("consumption");
                        output.setDao_type("tenantdata");
                        JSONObject dao_key = new JSONObject();
                        dao_key.put("building", building);
                        dao_key.put("tenant", tenant.getSign());
                        dao_key.put("energy_type", energy.getEnergy_type());
                        dao_key.put("meter_sign", detail.getMeter_sign());
                        dao_key.put("funcid", null);
                        output.setDao_key(FastJsonUtil.toString(dao_key));
                        output.setNeed_all_var_data(false);
                        output.setTime_period_intialized(false);
                        output.setTime_period("15min");
                        output.setMode("expression");
                        output.setOtherMap(otherMap);
                        output_meter = output;
                    }
                    CoreOutput CoreOutput_meterdata = CoreInstance.Convert_output(output_meter);
                    CoreOutput CoreOutput_meterfee = CoreInstance.Convert_output(output_meter);
                    CoreOutput_meterfee.output_sign = "tenantfee" + "_" + output_meter.getOutput_sign().substring("tenantdata".length() + 1);
                    CoreOutput_meterfee.dao_type = "tenantfee";
                    meterdataList.add(CoreOutput_meterdata);
                    meterfeeList.add(CoreOutput_meterfee);
                    StringBuffer meterdata_expression = new StringBuffer();
                    StringBuffer meterfee_expression = new StringBuffer();

                    if ("time_price".equals(energy.getPrice_type())) {
                        for (int i = 0; i < funcidList.size(); i++) {
                            long funcid = funcidList.get(i);
                            String time_priceName = time_priceNameList.get(i);
                            String expression = "servicedata_" + detail.getMeter_sign() + "_" + funcid;
                            if (detail.getShare_ratio() != null) {
                                expression = expression + "*" + detail.getShare_ratio();
                            }
                            if (meterdata_expression.length() > 0) {
                                meterdata_expression.append("+");
                                meterfee_expression.append("+");
                            }
                            meterdata_expression.append(expression);
                            meterfee_expression
                                    .append(expression + "*" + "other" + "_" + "time_price" + "_" + time_priceName + "_" + energy.getEnergy_type());
                        }
                    } else {
                        long funcid = funcidList.get(0);
                        String expression = "servicedata_" + detail.getMeter_sign() + "_" + funcid;
                        if (detail.getShare_ratio() != null) {
                            expression = expression + "*" + detail.getShare_ratio();
                        }
                        meterdata_expression.append(expression);
                        meterfee_expression.append(expression + "*" + "other" + "_" + "fixed_price" + "_" + energy.getEnergy_type());
                    }
                    CoreOutput_meterdata.expression = meterdata_expression.toString();
                    CoreOutput_meterfee.expression = meterfee_expression.toString();
                    typedata_expression.add(CoreOutput_meterdata.output_sign);
                    typefee_expression.add(CoreOutput_meterfee.output_sign);
                } // end meterIter
                CoreOutput_typedata.custom_paramsMap = StringList2StringMap(typedata_expression);
                CoreOutput_typefee.custom_paramsMap = StringList2StringMap(typefee_expression);
                fee_expression.add(CoreOutput_typefee.output_sign);

                if (!totalTypeEnergyMap.containsKey(key_energy)) {
                    totalTypeEnergyMap.put(key_energy, new ArrayList<String>());
                }
                List<String> totalTypeEnergy = totalTypeEnergyMap.get(key_energy);
                totalTypeEnergy.add(CoreOutput_typedata.output_sign);

                if (!totalTypeFeeMap.containsKey(key_energy)) {
                    totalTypeFeeMap.put(key_energy, new ArrayList<String>());
                }
                List<String> totalTypeFee = totalTypeFeeMap.get(key_energy);
                totalTypeFee.add(CoreOutput_typefee.output_sign);
            } // end energyIter
            CoreOutput_fee.custom_paramsMap = StringList2StringMap(fee_expression);
        } // end tenantIter

        instance.outputList.addAll(meterdataList);
        instance.outputList.addAll(meterfeeList);
        instance.outputList.addAll(typedataList);
        instance.outputList.addAll(typefeeList);
        instance.outputList.addAll(feeList);

        {
            Iterator<String> totalIter = totalTypeEnergyMap.keySet().iterator();
            while (totalIter.hasNext()) {
                String energy_type = totalIter.next();
                List<String> expression = totalTypeEnergyMap.get(energy_type);
                String time_begin = first_time_begin;
                String time_end = "99990101000000";
                Entity_ci_instanceoutput output = new Entity_ci_instanceoutput();
                output.setObject_sign(object_sign);
                output.setInstance_name(instance_name);
                output.setOutput_sign("tenantdata" + "_" + energy_type);
                output.setTime_begin(time_begin);
                output.setTime_end(time_end);
                output.setData_class("consumption");
                output.setDao_type("tenantdata");
                JSONObject dao_key = new JSONObject();
                dao_key.put("building", building);
                dao_key.put("tenant", null);
                dao_key.put("energy_type", energy_type);
                dao_key.put("meter_sign", null);
                dao_key.put("funcid", null);
                output.setDao_key(FastJsonUtil.toString(dao_key));
                output.setNeed_all_var_data(false);
                output.setTime_period_intialized(false);
                output.setTime_period("15min");
                output.setMode("custom");
                output.setCustom_function_name("custom_add");
                CoreOutput CoreOutput_total = CoreInstance.Convert_output(output);
                CoreOutput_total.custom_paramsMap = StringList2StringMap(expression);
                instance.outputList.add(CoreOutput_total);
            }
        }
        List<String> totalFeeExpression = new ArrayList<String>();
        {
            Iterator<String> totalIter = totalTypeFeeMap.keySet().iterator();
            while (totalIter.hasNext()) {
                String energy_type = totalIter.next();
                List<String> expression = totalTypeFeeMap.get(energy_type);
                String time_begin = first_time_begin;
                String time_end = "99990101000000";
                Entity_ci_instanceoutput output = new Entity_ci_instanceoutput();
                output.setObject_sign(object_sign);
                output.setInstance_name(instance_name);
                output.setOutput_sign("tenantfee" + "_" + energy_type);
                output.setTime_begin(time_begin);
                output.setTime_end(time_end);
                output.setData_class("consumption");
                output.setDao_type("tenantfee");
                JSONObject dao_key = new JSONObject();
                dao_key.put("building", building);
                dao_key.put("tenant", null);
                dao_key.put("energy_type", energy_type);
                dao_key.put("meter_sign", null);
                dao_key.put("funcid", null);
                output.setDao_key(FastJsonUtil.toString(dao_key));
                output.setNeed_all_var_data(false);
                output.setTime_period_intialized(false);
                output.setTime_period("15min");
                output.setMode("custom");
                output.setCustom_function_name("custom_add");
                CoreOutput CoreOutput_total = CoreInstance.Convert_output(output);
                CoreOutput_total.custom_paramsMap = StringList2StringMap(expression);
                instance.outputList.add(CoreOutput_total);
                totalFeeExpression.add(output.getOutput_sign());
            }
        }
        if (false) {
            String time_begin = first_time_begin;
            String time_end = "99990101000000";
            Entity_ci_instanceoutput output = new Entity_ci_instanceoutput();
            output.setObject_sign(object_sign);
            output.setInstance_name(instance_name);
            output.setOutput_sign("tenantfee");
            output.setTime_begin(time_begin);
            output.setTime_end(time_end);
            output.setData_class("consumption");
            output.setDao_type("tenantfee");
            JSONObject dao_key = new JSONObject();
            dao_key.put("building", building);
            dao_key.put("tenant", null);
            dao_key.put("energy_type", null);
            dao_key.put("meter_sign", null);
            dao_key.put("funcid", null);
            output.setDao_key(FastJsonUtil.toString(dao_key));
            output.setNeed_all_var_data(false);
            output.setTime_period_intialized(false);
            output.setTime_period("15min");
            output.setMode("custom");
            output.setCustom_function_name("custom_add");
            CoreOutput CoreOutput_total = CoreInstance.Convert_output(output);
            CoreOutput_total.custom_paramsMap = StringList2StringMap(totalFeeExpression);
            instance.outputList.add(CoreOutput_total);
        }
    }

    private static Map<String, String> StringList2StringMap(List<String> signList) {
        Map<String, String> result = new HashMap<String, String>();
        for (int i = 0; i < signList.size(); i++) {
            result.put("" + i, signList.get(i));
        }
        return result;
    }
}
