package com.sagacloud.util.compute_engine.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.entity.*;
import com.zillion.database.agent.ZillionAgent;
import com.zillion.util.zk.ZKWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.zookeeper.CreateMode;
import org.zillion.util.json.FastJsonUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
@Slf4j
public class InstanceUtil {
    public static void Add_tmp(List<String> children, String object_sign, String instance_name, String instance_name_tmp, ZKWrapper ZK,
                               ZillionAgent agent, String database_name) throws Exception {
        String name = object_sign + "_" + instance_name;
        String name_tmp = object_sign + "_" + instance_name_tmp;
        boolean exist = false;
        for (String child : children) {
            if (child.equals(name_tmp)) {
                exist = true;
                break;
            }
        }
        if (!exist) {
            int interval_seconds;
            if (name_tmp.contains("fjd_1")) {
                interval_seconds = ConstantCE.interval_seconds_fjd_1;
            } else if (name_tmp.contains("stat_Inst_stat")) {
                interval_seconds = ConstantCE.interval_seconds_stat_inststat;
            } else {
                interval_seconds = ConstantCE.interval_seconds_stat_consumption;
            }
            try {
                ZK.create(ConstantCE.zk_instance + "/" + name_tmp, "true".getBytes(), CreateMode.PERSISTENT);
            } catch (Exception e) {
               log.error(e.getMessage(),e);
            }
            try {
                ZK.create(ConstantCE.zk_status_request + "/" + name_tmp, "start".getBytes(), CreateMode.PERSISTENT);
            } catch (Exception e) {
               log.error(e.getMessage(),e);
            }
            try {
                ZK.create(ConstantCE.zk_compute_interval + "/" + name_tmp, ("" + interval_seconds).getBytes(), CreateMode.PERSISTENT);
            } catch (Exception e) {
               log.error(e.getMessage(),e);
            }
            String status_current = "start_idle";
            StatusUtil.Sync_status_current(database_name, object_sign, instance_name_tmp, status_current);
            int my_index = -1;
            for (int i = 0; i < children.size(); i++) {
                String child = children.get(i);
                if (child.equals(name)) {
                    my_index = i;
                    break;
                }
            }
            if (my_index != -1) {
                children.add(my_index + 1, name_tmp);
            }
        }

    }

    public static List<Entity_ci_instance> GetAllDetail(String database_name) throws Exception {
        List<Entity_ci_instance> instancelist = new ArrayList<Entity_ci_instance>();
        JSONObject Criteria = new JSONObject();
        JSONArray resultContent = QueryUtil.select(database_name, "ci_instance", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject contentItem = (JSONObject) resultContent.get(i);
            Entity_ci_instance detail = (Entity_ci_instance) FastJsonUtil.To_JavaObject(contentItem, Entity_ci_instance.class);

            instancelist.add(detail);
        }

        List<Entity_ci_instanceinput> inputListAll = new ArrayList<Entity_ci_instanceinput>();
        {
            JSONArray resultContentInner = QueryUtil.select(database_name, "ci_instanceinput", Criteria);
            for (int ii = 0; ii < resultContentInner.size(); ii++) {
                JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                Entity_ci_instanceinput entity = (Entity_ci_instanceinput) FastJsonUtil.To_JavaObject(computelog, Entity_ci_instanceinput.class);
                inputListAll.add(entity);
            }
        }
        List<Entity_ci_instanceoutput> outputListAll = new ArrayList<Entity_ci_instanceoutput>();
        {
            JSONArray resultContentInner = QueryUtil.select(database_name, "ci_instanceoutput", Criteria);
            for (int ii = 0; ii < resultContentInner.size(); ii++) {
                JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                Entity_ci_instanceoutput entity = (Entity_ci_instanceoutput) FastJsonUtil.To_JavaObject(computelog, Entity_ci_instanceoutput.class);
                outputListAll.add(entity);
            }
        }

        int index_tmp_input = 0;
        for (int i = 0; i < instancelist.size(); i++) {
            Entity_ci_instance instance = instancelist.get(i);
            List<Entity_ci_instanceinput> inputList = new ArrayList<Entity_ci_instanceinput>();
            for (int ii = index_tmp_input; ii < inputListAll.size(); ii++) {
                Entity_ci_instanceinput entity = inputListAll.get(ii);
                index_tmp_input = ii;
                int cmp1 = entity.getObject_sign().compareTo(instance.getObject_sign());
                int cmp2 = entity.getInstance_name().compareTo(instance.getInstance_name());
                if (cmp1 < 0) {
                    continue;
                } else if (cmp1 == 0) {
                    if (cmp2 < 0) {
                        continue;
                    } else if (cmp2 == 0) {
                        inputList.add(entity);
                    } else {
                        break;
                    }
                } else {
                    break;
                }
            }
            instance.setInputs(inputList.toArray(new Entity_ci_instanceinput[0]));
        }

        int index_tmp_output = 0;
        for (int i = 0; i < instancelist.size(); i++) {
            Entity_ci_instance instance = instancelist.get(i);
            List<Entity_ci_instanceoutput> outputList = new ArrayList<Entity_ci_instanceoutput>();
            for (int ii = index_tmp_output; ii < outputListAll.size(); ii++) {
                Entity_ci_instanceoutput entity = outputListAll.get(ii);
                index_tmp_input = ii;
                int cmp1 = entity.getObject_sign().compareTo(instance.getObject_sign());
                int cmp2 = entity.getInstance_name().compareTo(instance.getInstance_name());
                if (cmp1 < 0) {
                    continue;
                } else if (cmp1 == 0) {
                    if (cmp2 < 0) {
                        continue;
                    } else if (cmp2 == 0) {
                        outputList.add(entity);
                    } else {
                        break;
                    }
                } else {
                    break;
                }
            }
            instance.setOutputs(outputList.toArray(new Entity_ci_instanceoutput[0]));
        }

        return instancelist;
    }

    public static Entity_ci_status Get_status(String database_name, String object_sign, String instance_name) throws Exception {
        Entity_ci_status result = null;
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONArray resultContent = QueryUtil.select(database_name, "ci_status", Criteria);
        if (resultContent.size() > 0) {
            JSONObject contentItem = (JSONObject) resultContent.get(0);
            result = (Entity_ci_status) FastJsonUtil.To_JavaObject(contentItem, Entity_ci_status.class);
        }
        return result;
    }

    public static List<Entity_ci_status> GetList_status(String database_name) throws Exception {
        List<Entity_ci_status> instancelist = new ArrayList<Entity_ci_status>();
        JSONObject Criteria = new JSONObject();
        JSONArray resultContent = QueryUtil.select(database_name, "ci_status", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject contentItem = (JSONObject) resultContent.get(i);
            Entity_ci_status detail = (Entity_ci_status) FastJsonUtil.To_JavaObject(contentItem, Entity_ci_status.class);

            instancelist.add(detail);
        }
        return instancelist;
    }

    public static Entity_ci_instances GetAll(String database_name) throws Exception {
        List<Entity_ci_instance> instancelist = new ArrayList<Entity_ci_instance>();
        JSONObject Criteria = new JSONObject();
        JSONArray resultContent = QueryUtil.select(database_name, "ci_instance", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject contentItem = (JSONObject) resultContent.get(i);
            Entity_ci_instance detail = (Entity_ci_instance) FastJsonUtil.To_JavaObject(contentItem, Entity_ci_instance.class);

            instancelist.add(detail);
        }
        Entity_ci_instances result = new Entity_ci_instances();
        result.setInstances(instancelist.toArray(new Entity_ci_instance[0]));
        return result;
    }

    public static Entity_ci_instance Get(String database_name, String object_sign, String instance_name) throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONArray resultContent = QueryUtil.select(database_name, "ci_instance", Criteria);
        if (resultContent.size() > 0) {
            JSONObject contentItem = (JSONObject) resultContent.get(0);
            Entity_ci_instance detail = (Entity_ci_instance) FastJsonUtil.To_JavaObject(contentItem, Entity_ci_instance.class);

            List<Entity_ci_instanceinput> inputList = new ArrayList<Entity_ci_instanceinput>();
            JSONArray resultContentInner = QueryUtil.select(database_name, "ci_instanceinput", Criteria);
            for (int ii = 0; ii < resultContentInner.size(); ii++) {
                JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                Entity_ci_instanceinput entity = (Entity_ci_instanceinput) FastJsonUtil.To_JavaObject(computelog, Entity_ci_instanceinput.class);
                inputList.add(entity);
            }
            detail.setInputs(inputList.toArray(new Entity_ci_instanceinput[0]));

            List<Entity_ci_instanceoutput> outputList = new ArrayList<Entity_ci_instanceoutput>();
            resultContentInner = QueryUtil.select(database_name, "ci_instanceoutput", Criteria);
            for (int ii = 0; ii < resultContentInner.size(); ii++) {
                JSONObject computelog = (JSONObject) resultContentInner.get(ii);
                Entity_ci_instanceoutput entity = (Entity_ci_instanceoutput) FastJsonUtil.To_JavaObject(computelog, Entity_ci_instanceoutput.class);
                outputList.add(entity);
            }
            detail.setOutputs(outputList.toArray(new Entity_ci_instanceoutput[0]));

            return detail;
        }

        return null;
    }

    public static void Request(String database_name, String object_sign, String instance_name, String status_request)
            throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONObject Set = new JSONObject();
        Set.put("status_request", status_request);
        QueryUtil.update(database_name, "ci_status", Criteria, Set);
    }

    public static void Delete_fake(String database_name, String object_sign, String instance_name) throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONObject Set = new JSONObject();
        Set.put("flag_valid", 0L);
        QueryUtil.update(database_name, "ci_instance", Criteria, Set);
    }

    public static void Delete(String database_name, String object_sign, String instance_name) throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        QueryUtil.delete(database_name, "ci_instance", Criteria);
        QueryUtil.delete(database_name, "ci_instanceinput", Criteria);
        QueryUtil.delete(database_name, "ci_instanceoutput", Criteria);
        QueryUtil.delete(database_name, "ci_status", Criteria);
    }

    public static void Insert(String database_name, Entity_ci_instance instance) throws Exception {
        for (Entity_ci_instanceinput input : instance.getInputs()) {
            input.setObject_sign(instance.getObject_sign());
            input.setInstance_name(instance.getInstance_name());
        }
        JSONArray InsertObjects = new JSONArray();
        for (Entity_ci_instanceinput input : instance.getInputs()) {
            JSONObject json = (JSONObject) FastJsonUtil.To_JSON(input);
            InsertObjects.add(json);
        }
        QueryUtil.batch_insert(database_name, "ci_instanceinput", InsertObjects);

        for (Entity_ci_instanceoutput input : instance.getOutputs()) {
            input.setObject_sign(instance.getObject_sign());
            input.setInstance_name(instance.getInstance_name());
        }
        InsertObjects = new JSONArray();
        for (Entity_ci_instanceoutput input : instance.getOutputs()) {
            JSONObject json = (JSONObject) FastJsonUtil.To_JSON(input);
            InsertObjects.add(json);
        }
        QueryUtil.batch_insert(database_name, "ci_instanceoutput", InsertObjects);

        {
            JSONObject InsertObject = new JSONObject();
            InsertObject.put("object_sign", instance.getObject_sign());
            InsertObject.put("instance_name", instance.getInstance_name());
            InsertObject.put("flag_valid", instance.getFlag_valid());
            InsertObject.put("compute_interval_seconds", instance.getCompute_interval_seconds());
            QueryUtil.insert(database_name, "ci_instance", InsertObject);
        }
    }

    public static void Insert_status(String database_name, Entity_ci_instance instance, String status_request) throws Exception {
        JSONObject InsertObject = new JSONObject();
        InsertObject.put("object_sign", instance.getObject_sign());
        InsertObject.put("instance_name", instance.getInstance_name());
        InsertObject.put("status_request", status_request);
        QueryUtil.insert(database_name, "ci_status", InsertObject);
    }

    public static void Update_status_current(String agent_name, String database_name, String object_sign, String instance_name,
                                             String status_current) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONObject Set = new JSONObject();
        Set.put("status_current", status_current);
        Set.put("operate_time", sdf.format(new Date()));
        Set.put("operate_owner", agent_name + " " + Thread.currentThread().getName());
        QueryUtil.update(database_name, "ci_status", Criteria, Set);
    }

    public static void Update_compute_round(String database_name, String object_sign, String instance_name, long compute_round)
            throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("object_sign", object_sign);
        Criteria.put("instance_name", instance_name);
        JSONObject Set = new JSONObject();
        Set.put("compute_round", compute_round);
        QueryUtil.update(database_name, "ci_status", Criteria, Set);
    }
}
