package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.fjd.TableUtil;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.zillion.util.table.ZillionTableColumn;
import com.zillion.util.table.ZillionTableColumnEnum;
import com.zillion.util.table.ZillionTableSchema;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;

@Slf4j
public class Reset_EMS {

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }


        String table_name = "ci_instance";
        ZillionTableSchema schema = HBaseSaveManagerRepository.randomZillionAgent().container.repositoryMap.get(ConstantCE.database_name).GetTable(table_name);

        JSONObject Criteria = new JSONObject();
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "select");
        wrapperObject.put("Criteria", Criteria);
        wrapperObject.put("Database", ConstantCE.database_name);
        wrapperObject.put("Datatable", table_name);
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        JSONArray resultContent = (JSONArray) queryResult.get("Content");
        MyPrint_EMS(schema, resultContent);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            if (!"EMS".equals(item.get("instance_name"))) {
                continue;
            }

            String object_sign = (String) item.get("object_sign");
            String instance_name = (String) item.get("instance_name");
            JSONObject CriteriaInner = new JSONObject();
            CriteriaInner.put("object_sign", object_sign);
            CriteriaInner.put("instance_name", instance_name);
            JSONObject SetInner = new JSONObject();
            SetInner.put("status_current", "start_rest");
            SetInner.put("compute_round", null);

            String[] table_names = {"ce_computeinputdetail", "ce_computeinputlog", "ce_computeoutputdetail", "ce_computelog", "ce_curround",
                    "ce_preroundindex"};
            for (String name : table_names) {
                JSONObject wrapperObjectInner = new JSONObject();
                wrapperObjectInner.put("QueryType", "delete");
                wrapperObjectInner.put("Criteria", CriteriaInner);
                wrapperObjectInner.put("Database", ConstantCE.database_name);
                wrapperObjectInner.put("Datatable", name);
                HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObjectInner);
            }
            {
                JSONObject wrapperObjectInner = new JSONObject();
                wrapperObjectInner.put("QueryType", "update");
                wrapperObjectInner.put("Criteria", CriteriaInner);
                wrapperObjectInner.put("Set", SetInner);
                wrapperObjectInner.put("Database", ConstantCE.database_name);
                wrapperObjectInner.put("Datatable", "ci_status");
                HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObjectInner);
            }
            log.warn(object_sign);
        }

        HBaseSaveManagerRepository.randomZillionAgent().DDL_DropTable(ConstantCE.database_name, "data_objectdata");
        HBaseSaveManagerRepository.randomZillionAgent().DDL_DropTable(ConstantCE.database_name, "data_objectdata_max");
        HBaseSaveManagerRepository.randomZillionAgent().DDL_DropTable(ConstantCE.database_name, "data_energydata");
        HBaseSaveManagerRepository.randomZillionAgent().DDL_DropTable(ConstantCE.database_name, "data_energydata_max");
        TableUtil.AddTables(ConstantCE.database_name);


        System.out.println();
    }

    static void MyPrint_EMS(ZillionTableSchema schema, JSONArray resultContent) {
        List<String> columnList = new ArrayList<String>();
        for (String column : schema.Key) {
            columnList.add(column);
        }
        for (String column : schema.OtherColumn) {
            columnList.add(column);
        }

        for (String column : columnList) {
            System.out.printf("%20s", column);
            System.out.print("\t");
        }
        System.out.println();
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            if (!"EMS".equals(item.get("instance_name"))) {
                continue;
            }
            for (String column : columnList) {
                ZillionTableColumn column_schema = schema.ColumnMap.get(column);
                if (column_schema.Type == ZillionTableColumnEnum.BOOLEAN) {
                    System.out.printf("%20s", ((Boolean) item.get(column)) ? "true" : "false");
                } else if (column_schema.Type == ZillionTableColumnEnum.LONG) {
                    System.out.printf("%20d", (Long) item.get(column));
                } else if (column_schema.Type == ZillionTableColumnEnum.DOUBLE) {
                    System.out.printf("%20.2f", (Double) item.get(column));
                } else if (column_schema.Type == ZillionTableColumnEnum.STRING) {
                    System.out.printf("%20s", (String) item.get(column));
                }
                System.out.print("\t");
            }
            System.out.println();
        }
    }
}
