package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.fjd.TableUtil;
import com.sagacloud.util.compute_engine.util.QueryUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class Test_logger {
    static SimpleDateFormat sdf_ = new SimpleDateFormat("yyyyMMddHHmmss");

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        String database_name = "db_public";
        String table_name = "data_energydata_15min";
        if (!QueryUtil.database_exist(database_name)) {
            HBaseSaveManagerRepository.randomZillionAgent().NDL_AddDatabase(database_name);
        }
        if (!QueryUtil.table_exist(database_name, table_name)) {
            TableUtil.AddTable(database_name, table_name);
        }
        String building = "9901010001";
        List<String> energyModelNodeSignList = new ArrayList<String>();
        energyModelNodeSignList.add("EI1001");
        energyModelNodeSignList.add("EI10101001");
        energyModelNodeSignList.add("EI10101002");
        energyModelNodeSignList.add("EI10101003");
        energyModelNodeSignList.add("EI10102001");
        energyModelNodeSignList.add("EI10102002");
        energyModelNodeSignList.add("EI10102003");
        energyModelNodeSignList.add("EI1010201001");
        energyModelNodeSignList.add("EI1010201002");
        Date tmpDate = sdf_.parse("19900101000000");
        for (String energyModelNodeSign : energyModelNodeSignList) {
            {
                JSONObject Criteria = new JSONObject();
                Criteria.put("building", building);
                Criteria.put("energyModelSign", building + "EM01");
                Criteria.put("energyModelNodeSign", energyModelNodeSign);
                Criteria.put("data_time", sdf_.format(tmpDate));
                QueryUtil.delete(database_name, table_name, Criteria);
            }
            {
                JSONArray InsertObjects = new JSONArray();
                JSONObject InsertObject = new JSONObject();
                InsertObject.put("building", building);
                InsertObject.put("energyModelSign", building + "EM01");
                InsertObject.put("energyModelNodeSign", energyModelNodeSign);
                InsertObject.put("data_time", sdf_.format(tmpDate));
                InsertObject.put("data_value", 250.0);
                InsertObjects.add(InsertObject);
                QueryUtil.batch_insert(database_name, table_name, InsertObjects);
            }
        }
        for (String energyModelNodeSign : energyModelNodeSignList) {
            {
                JSONObject Criteria = new JSONObject();
                Criteria.put("building", building);
                Criteria.put("energyModelSign", building + "EM01");
                Criteria.put("energyModelNodeSign", energyModelNodeSign);
                Criteria.put("data_time", sdf_.format(tmpDate));
                QueryUtil.delete(database_name, table_name, Criteria);
            }
            {
                JSONObject InsertObject = new JSONObject();
                InsertObject.put("building", building);
                InsertObject.put("energyModelSign", building + "EM01");
                InsertObject.put("energyModelNodeSign", energyModelNodeSign);
                InsertObject.put("data_time", sdf_.format(tmpDate));
                InsertObject.put("data_value", 250.0);
                QueryUtil.insert(database_name, table_name, InsertObject);
            }
        }


    }

}
