package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

@Slf4j
public class delete_original_month_null {
    static String database_name = "ems_data";
    static String[] buildings = {"4419000001", "4419000012"};
    static String time_from = "20180401000000";
    static String time_to = "20180601000000";

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        for (String building : buildings) {
            ProcessBuilding(database_name, building);
        }


        System.out.println();
    }

    static void ProcessBuilding(String database_name, String building) throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "select");
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", "original_present");
        wrapperObject.put("Criteria", Criteria);
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        JSONArray resultContent = (JSONArray) queryResult.get("Content");
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            String meter = (String) item.get("meter");
            long funcid = (Long) item.get("funcid");
            ProcessPoint(database_name, building, meter, funcid, time_from, time_to);
            if (i != 0 && i % 100 == 0) {
                log.warn(i + "/" + resultContent.size());
            }
        }
    }

    static void ProcessPoint(String database_name, String building, String meter, long funcid, String time_from, String time_to)
            throws Exception {
        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        JSONObject Range = new JSONObject();
        Range.put("$gte", time_from);
        Range.put("$lt", time_to);
        Criteria.put("receivetime", Range);
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "select");
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", "original_month");
        wrapperObject.put("Criteria", Criteria);
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        JSONArray resultContent = (JSONArray) queryResult.get("Content");
        boolean has_null = false;
        String null_time_from = null;
        String null_time_to = null;
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            String receivetime = (String) item.get("receivetime");
            Double data = (Double) item.get("data");
            if (data == null) {
                if (has_null) {
                    null_time_to = receivetime;
                } else {
                    has_null = true;
                    null_time_from = receivetime;
                    null_time_to = receivetime;
                }
            }

            if (data != null || i == resultContent.size() - 1) {
                if (has_null) {
                    item.remove("data");
                    item.remove("receivetime");
                    JSONObject RangeInner = new JSONObject();
                    RangeInner.put("$gte", null_time_from);
                    RangeInner.put("$lte", null_time_to);
                    item.put("receivetime", RangeInner);
                    log.warn(FastJsonUtil.toFormatString(item));
                    JSONObject wrapperObjectInner = new JSONObject();
                    wrapperObjectInner.put("QueryType", "delete");
                    wrapperObjectInner.put("Database", database_name);
                    wrapperObjectInner.put("Datatable", "original_month");
                    wrapperObjectInner.put("Criteria", item);
                    HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObjectInner);

                    has_null = false;
                    null_time_from = null;
                    null_time_to = null;
                }
            }

        }
    }
}
