package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

@Slf4j
public class modify_building {
    static String database_name = "db_time_data";
    static String[] months = {"201706", "201707", "201708", "201709", "201710", "201711", "201712", "201801", "201802", "201803", "201804",
            "201805"};
    static String building_old = "3101140002";
    static String building_new = "1101020001";
    static int thread_count = 20;
    static List<JSONObject> itemList = new ArrayList<JSONObject>();
    static Random rand = new Random();

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building_old);
        JSONArray resultContent = QueryUtil.select(database_name, "original_present", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject resultItem = (JSONObject) resultContent.get(i);
            String meter = (String) resultItem.get("meter");
            Long funcid = (Long) resultItem.get("funcid");
            for (String month : months) {
                JSONObject item = new JSONObject();
                item.put("month", month);
                item.put("building_old", building_old);
                item.put("building_new", building_new);
                item.put("meter", meter);
                item.put("funcid", funcid);
                itemList.add(item);
            }
        }

        List<modify_building_Thread> threadList = new ArrayList<modify_building_Thread>();
        for (int index = 0; index < thread_count; index++) {
            modify_building_Thread thread = new modify_building_Thread(database_name);
            thread.start();
            threadList.add(thread);
        }

        while (true) {
            Thread.sleep(1L);

            boolean all_finish = true;
            for (modify_building_Thread thread : threadList) {
                if (thread.isAlive()) {
                    all_finish = false;
                    break;
                }
            }
            if (all_finish) {
                break;
            }
        }


        System.out.println();
    }

    public static synchronized JSONObject Pop() {
        JSONObject item = null;
        if (itemList.size() > 0) {
            item = itemList.remove(0);
            String building = (String) item.get("building");
            String meter = (String) item.get("meter");
            Long funcid = (Long) item.get("funcid");
            log.warn(building + "\t" + meter + "\t" + funcid + "\t" + itemList.size());
        }
        return item;
    }
}
